;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; EFS based simulator
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; area for setting patameter values
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to set_scenareo  ; initialise scenareo parameters

;  set change_in_non_comms_based_expenditure% 10  
;  set income_inflation% 5.0
;  if years = 0 [set income_inflation% 1.3]
;  if years = 1 [set income_inflation% 2.0]
;  if years = 2 [set income_inflation% 4.0]    
;  if years = 3 [set income_inflation% 0.5]
;  if years = 4 [set income_inflation% 1.8]    
      
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; data description
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

extensions [profiler]
globals [
  pop current_year years hsize houses myage currentcase currenthouse maxhouseholds
  totseconddwelling income pcexpcommunication pcexpclothing pcexpseconddwelling pcexpinternet
  tottelecom totnontelecom pcexptelecom pcexpnontelecom pcinctelecom pcincnontelecom
  totfood totalcohol totclothing tothousing totfurniture tothealth tottransport totcommunication
  meanfood meanalcohol meanclothing meanhousing meanfurniture meanhealth meantransport meancommunication
  totrecreation toteduc tothotels totmisc tototherexp totoldhhincome
  meanrecreation meaneduc meanhotels meanmisc meanotherexp
  pcincfood pcincalcohol pcincclothing pcinchousing pcincfurniture pcinchealth pcinctransport
  pcinccommunication pcincrecreation pcinceduc pcinchotels pcincmisc pcincotherexp
  pcincseconddwelling pcincinternet pcincsaved
  mean_population_income target_mean_population_income
  fnew fold anew aold cnew cold tnew told enew eold
  comnew comold hnew hold healthnew healthold furnew furold
  rnew rold hotnew hotold births deaths startpopulation
  totexp0 food0 alcohol0 clothing0 housing0 furniture0 health0
  transport0 communication0 recreation0 educ0 hotels0 misc0
  
  ho1m ho2m ho3m ho4m ho5m ho6m
  he1m he2m he3m he4m he5m he6m
  t1m t2m t3m t4m t5m t6m
  f1m f2m f3m f4m f5m f6m
  ag0 ag1 ag2 ag3 ag4 ag5  
  counter
  pcsingle pcmarried pccohab pcseparated pcdivorced pcwidowed upper lower
  mm mms fm fms mcs fcs fc mc nmales nfem h1 h2 h3 h4 currentagent
  totincome totinternet meaninternet meanseconddwelling
  meantelecom meannontelecom toteffectiveincome
  tempsaved totsaved meansaved pcexpsaved
  totexp meanexp meanage
  pclow pcmedium pchigh low medium high flow mflow fmed mfmed fhigh mfhigh pcother othergroup fother mfother
  type1pc type2pc type3pc type4pc type5pc type6pc    ; household type percentages
  q1 q2 q3 q4 changeeffective

  q2floor  ; second quartile household income boundaries
  q3floor  ; third quartile household income boundaries
  q4floor  ; highest quartile household income boundaries
  
  gtemptotalexpenditure   ; temporary variables for copying expenditures
  gtempinternet
  gtempseconddwelling
  gtempsaved
  gtempincanon
  gtemptelecom
  gtempnontelecom
  gtempeffectiveincome
  gtempfood
  gtempalcohol
  gtempclothing  
  gtemphousing
  gtempfurniture
  gtemphealth
  gtemptransport
  gtempcommunication  
  gtemprecreation
  gtempeduc
  gtemphotels
  gtempmisc
  gtempotherexp
]

patches-own [
  pcase               ; patch address
  originalID          ; id from efs
  weight              ; household weight
  occupied            ; patch currently occupied
  currenttype         ; current household classification number
  lasttype            ; previous classification
  oldhhincome         ; household income last year
  numoccupants        ; number of people in the household
  oldnumoccupants     ; number of occupants last time period
  houseageband        ; decade age band of oldest household member
  oldhouseageband     ; household age band last period
  older               ; moved between age bands
  males               ; number of males in household 
  females             ; number of females in household
  incchange           ; income changed due to demographic change
  food                ; spending on food
  fuel                ; spending on fuel
  young               ; number of under 30s
  midage              ; number aged 30 to 60
  old                 ; number over 60 
  housesize           ; number in house 
  axpmg               ; monthly mortgage
  aregion             ; region 
  ahstype             ; type of accommodation 
  ahsval              ; value of property
  arentg              ; gross rent
  totalexpenditure    ; total monthly household expenditure
  incanon             ; weekly household income
  hhincome            ; household income sum of individual incomes within household
  targetincome        ; income after annual change
  effectiveincome     ; incanon modified by change in energy costs
  oldeffectiveincome  ; previous effective income
  internet            ; weekly internet subscription
  communication       ; weekly communication expenditure
  seconddwelling      ; weekly expenditure on second home
  saved               ; weekly amount saved or invested
  nontelecom          ; not telecom related
  telecom             ; potential telecom recreationiture
  alcohol             ; weekly spending on alcohol & tabacco
  clothing            ; weekly expenditure on clothing & footwear
  housing             ; weekly spending on housing, water, electricity
  furniture           ; weekly furnishings & carpets
  health              ; weekly health costs
  transport           ; weekly transport costs
  recreation          ; weekly recreation expenditure
  educ                ; weekly education costs
  hotels              ; weekly expenditure on hotels & restaurants
  misc                ; miscelaneous expenditure
  otherexp            ; other expenditure
  mortgage            ; mortgage interest payment
  nclass              ; ns-sec8 of HRP
  class               ; professional, intermediate, routine, other
  culture             ; most schooled household member
  changes_pending     ; household expenditures should be updated this year
  used                ; been donor in current cycle
  oldest              ; age of the oldest household occupant
  
  ptemptotalexpenditure   ; temporary variables for copying expenditures
  ptempclothing
  ptempinternet
  ptempcommunication
  ptempseconddwelling
  ptempsaved
  ptempincanon
  ptemptelecom
  ptempnontelecom
  ptempeffectiveincome
  ptempfood
  ptempalcohol
  ptemphousing
  ptempfurniture
  ptemphealth
  ptemptransport
  ptemprecreation
  ptempeduc
  ptemphotels
  ptempmisc
  ptempotherexp
]

turtles-own [
  case           ; case number
  partnerid      ; who number of partner
  parentid       ; who number of parent
  person         ; household member number
  homex          ; x coordinate of original address
  homey          ; y coordinate of original address
  age            ; years
  under20        ; aged under 20
  twenties       ; aged in twenties
  thirties       ; aged in thirties
  forties        ; aged in forties
  fifties        ; aged in fifties
  sixties        ; aged 60 and overi  
  sex            ; male female
  nsex           ; numerical sex read from file
  nstatus        ; numerical marrital status read from file
  status         ; married cohabiting single widowed divorced separated samesex
  previousstatus ; previous marital status
  newwidow       ; widowed in current mortality module
  newlyseparated ; 0 = no: number indicates time since separation in years
  children       ; number of children born by agent
  numdependents  ; number of agents responsible for
  newbirth       ; birth in current fertility module
  numinhouse     ; number of individuals in the household
  student        ; currently a full time student
  education      ; age completed full time education
  changed        ; recent change indicator
  newcohabit     ; cohabitation began in current year
  nemployment    ; numerical employment status from file
  employment     ; type of employment
  ajbhrs         ; hours worked per week
  asaved         ; amount saved each month
  apaygyr        ; gross earnings last 12 months
  ajbpl          ; work location
  ajbttwm        ; means of travel to work
  ajbttwt        ; minutes spent travelling to work
  neducation     ; age when left education secondary, college, university
  parentsclass   ; ns-sec8 of hoh at birth
  myclass        ; current social class ns-sec8
  incomechange   ; change in income this year due to education or retirement
  livewithparents
]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; initialisation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to setup
  clear-all
  init-patches     ; read household data from file 
  initialise       ; read individual level data from file
  if apply_weights = true [
    applyhouseholdweights
  ]
  findparents
  set current_year 2006
  set years 0
  set mm 0
  set mms 0
  set fm 0
  set fms 0
  set changeeffective 1
  carefully [file-delete "output2006.txt"] []
  carefully [file-delete "output2011.txt"] []
  carefully [file-delete "output2016.txt"] []
  carefully [file-delete "output2021.txt"] []
  carefully [file-delete "output2026.txt"] []
  carefully [file-delete "output2031.txt"] []  
  carefully [file-delete "output2036.txt"] []  
  show "files deleted"
  set startpopulation count turtles
  set propensity_to_marry 1
  set propensity_to_divorce 1
  set propensity_to_cohabit 1
  set propensity_to_split 1
  set birth_rate 1
  set mortality_rate 1
  if alignment = true [
    set mortality_rate mortality_rate + 0.45
    set birth_rate birth_rate + ((11 / 100) * birth_rate)
  ]
  ask patches [if pcase = 1 [set pcolor green]]
  show "patch colour set"
  set q2floor 273  ; initialise quartile household incomes
  set q3floor 485
  set q4floor 817
  show "clearing patches"
  clear_patches
  show "patches cleared"
  occupy_patches
  show "patches occupied"
  set_hrp_class
  show "hrp class set"
  set_scenareo                      ; set up parameters for running model
  show "scenario set"
  initial_household_classification  ; set type of household based on demographics
  show "households classified"

  impute_initial_income                     ; set income for cases with missing values
  show "income imputed"
  initialise_temp_expenditures      ; avoid copying zero values when change_expenditures runs for the first time
  impute_missing_expenditures       ; set expenditures for cases with missing expenditure data
  ;change_expenditures
  show "lowest incomes"
  show min [incanon] of patches with [occupied = 1]
  show min [ptempincanon] of patches with [occupied = 1]
  
  set ho1m mean [housing] of patches with [houseageband = 1]
  set ho2m mean [housing] of patches with [houseageband = 2]
  set ho3m mean [housing] of patches with [houseageband = 3]
  set ho4m mean [housing] of patches with [houseageband = 4]
  set ho5m mean [housing] of patches with [houseageband = 5]
  set ho6m mean [housing] of patches with [houseageband = 6]
 
  set he1m mean [health] of patches with [houseageband = 1]
  set he2m mean [health] of patches with [houseageband = 2]
  set he3m mean [health] of patches with [houseageband = 3]
  set he4m mean [health] of patches with [houseageband = 4]
  set he5m mean [health] of patches with [houseageband = 5]
  set he6m mean [health] of patches with [houseageband = 6]   
  
  set t1m mean [transport] of patches with [houseageband = 1]
  set t2m mean [transport] of patches with [houseageband = 2]
  set t3m mean [transport] of patches with [houseageband = 3]
  set t4m mean [transport] of patches with [houseageband = 4]
  set t5m mean [transport] of patches with [houseageband = 5]
  set t6m mean [transport] of patches with [houseageband = 6]
  
  set f1m mean [food] of patches with [houseageband = 1]
  set f2m mean [food] of patches with [houseageband = 2]
  set f3m mean [food] of patches with [houseageband = 3]
  set f4m mean [food] of patches with [houseageband = 4]
  set f5m mean [food] of patches with [houseageband = 5]
  set f6m mean [food] of patches with [houseageband = 6]

  summarise
  outputexpenditures
  show "showagechanges"
  showagechanges
  show "no inc in setup"
  show count patches with [incanon <= 0 and occupied = 1]  
  write_file
  update-plot
  reset-ticks
end

to init-patches        ; read in household data
  let numhouses 0      ; house counter
  let lasthouse 0      ; highest house so far
  set currenthouse 0   ; number of current household
  ask patches [set pcase 0 set occupied 0]
  file-open "households.txt"
  while [not file-at-end?] [
    set currenthouse file-read           ; household case id
      if currenthouse > lasthouse [
      set numhouses numhouses + 1
      if numhouses > households  [file-close stop]
      ask one-of patches with [pcase = 0] [
        set occupied 1
        set pcase currenthouse
        set housesize file-read          ; number in household a049
        set totalexpenditure file-read   ; total weekly household expenditure p630tp
        set internet file-read           ; internet subscription fees c94245
        set incanon file-read            ; weekly household income incanon
        set weight file-read             ; household weight weighta
        set nontelecom file-read         ; total recreation not telecom related
        set telecom file-read            ; total recteation expenditure telecom related
        set food file-read               ; total food p601t
        set alcohol file-read            ; total alcohol & tobacco p602t
        set clothing file-read           ; total clothing & footwear p603t
        set housing file-read            ; total housing, water, electricity p604t
        set furniture file-read          ; total furniture, carpets etc. p605t
        set health file-read             ; total health p606t
        set transport file-read          ; total transport p607t
        set communication file-read      ; total communication p608t
        set recreation file-read         ; total recreation p609t
        set educ file-read               ; total education p610t
        set hotels file-read             ; total hotels & restaurants p611t
        set misc file-read               ; miscelaneous p612t
        set mortgage file-read           ; monthly mortgage payment
        set nclass file-read             ; ns-sec8 of HRP     
        set originalID pcase
        ;show "originalID"
        ;show originalID
        if housesize < 0 [set housesize 0]        ; allow for missing data
        if totalexpenditure < 0 [set totalexpenditure 0]
        if internet < 0 [set internet 0]
        if incanon < 0 [set incanon 0]
        ;if incanon = 0 [set weight 0]
        if food < 0 [set food 0]
        if alcohol < 0 [set alcohol 0]        
        if clothing < 0 [set clothing 0]
        if housing < 0 [set housing 0]
        if furniture < 0 [set furniture 0]
        if health < 0 [set health 0]
        if transport < 0 [set transport 0]
        if communication < 0 [set communication 0]
        if recreation < 0 [set recreation 0]
        if educ < 0 [set educ 0]
        if hotels < 0 [set hotels 0]
        if misc < 0 [set misc 0]
        ;if weight >= 5 [set weight 5]    keep original weight
        set effectiveincome incanon
        if effectiveincome < 0 [set effectiveincome 0]
        set oldhhincome incanon
        set oldeffectiveincome incanon
        set otherexp totalexpenditure - (food + alcohol + clothing + housing + furniture + health + transport + communication + recreation + educ + hotels + misc)
        if mortgage < 0 [set mortgage 0]

        if nclass <= 0 [set nclass 0 set class "NS-SEC 0"]
        if nclass = 1 [set class "NS-SEC 1"]
        if nclass = 2 [set class "NS-SEC 2"]
        if nclass = 3 [set class "NS-SEC 3"]        
        if nclass = 4 [set class "NS-SEC 4"]
        if nclass = 5 [set class "NS-SEC 5"]        
        if nclass = 6 [set class "NS-SEC 6"]       
        if nclass = 7 [set class "NS-SEC 7"]       
        if nclass = 8 [set class "NS-SEC 8"]
        if nclass = 9 [set class "NS-SEC 9"]       
        if nclass = 10 [set class "NS-SEC 10"]        
        if nclass = 11 [set class "NS-SEC 11"]        
        if nclass >= 12 [set class "NS-SEC 12"]        
                    
        if nclass = 0 or nclass >= 9 [set class "Inactive"]
      ]
      set lasthouse currenthouse
    ]  
  ]
  file-close
  show "finished reading house file"
  show min [incanon] of patches with [occupied = 1]  
end

to initialise  ; set up initial agent population
  let r 0.0
  let recnum 0
  let finished 0
  set maxhouseholds max [pcase] of patches
  file-open "individuals.txt"
  while [not file-at-end? and finished = 0] [
    set recnum file-read
    if-else recnum <= maxhouseholds [
      cro 1 [                     ; create a new agent
        set case recnum           ; set turtle identifier from file
        set currentcase case      ; set current case number
        set person file-read      ; household person index number 
        set age file-read         ; age
        set nsex file-read        ; gender code number
        set nstatus file-read     ; marital status code number
        set student file-read     ; currently a full time student
        set neducation file-read  ; age completed full time education

        setagebands  ; initialise or update age bands according to current age
        
        if nsex = 1 [set sex "male" set color blue]
        if nsex = 2 [set sex "female" set color pink]
      
        if nstatus <= 0 [set status "single"]
        if nstatus = 1 [set status "married"]
        if nstatus = 2 [set status "cohabiting"]
        if nstatus = 3 [set status "single"]
        if nstatus = 4 [set status "widowed"]
        if nstatus = 5 [set status "divorced"]
        if nstatus = 6 [set status "separated"]
        if nstatus = 7 [set status "same sex couple"]
        if nstatus = 8 [set status "civil partnership"]
        if nstatus >= 9 [set status "single"]
        
        set previousstatus "single"
        if status = "separated" [set previousstatus "married"]
        if status = "widowed" [set previousstatus "married"]
        if status = "divorced" [set previousstatus "separated"]
        
        set student 0
        if age <= 16 [set student 1]
        
        ifelse any? patches with [pcase = currentcase] [
          move-to one-of patches with [pcase = currentcase]  ; go to the family address
          set homex pxcor          ; initialise original address
          set homey pycor          ; initialise original address
          ;show nclass
          set parentsclass nclass  ; initialise class of origin
          set myclass parentsclass ; initialise agent's class
          if student = 1 [set myclass 10]
        ]
        [show "patch not found" die]
      ]
    ]    
    [set finished 1]
  ]
  file-close
  show "finished reading agent file"
end

to applyhouseholdweights
  let r 0.0
  let w 0.0

  ask patches with [occupied = 1] [
    if incanon <= 0 [show "incanon    " show incanon]
    set r random-float 1
    if weight = 0 [delete_household]        ; ignore households with zero weight
    if weight < 1 [if r >= weight [delete_household]]  ; select households according to probability derived from weight
    ; if weight = 1 do nothing
    set w weight
    while [w >= 2] [
      if incanon <= 0 [show "income less than 0"]
      store_expenditures
      copy_household
      copy_turtles
      set w w - 1
    ]
    if r < (w - 1) [store_expenditures copy_household copy_turtles]
  ]
  show "weights applied"
end

to clear_patches
  ask patches with [count turtles-here = 0] [
    clear_patch
  ]
end

to occupy_patches
  ask patches with [count turtles-here > 0] [set occupied 1]
  ;show count patches with [occupied = 1] 
end

to clear_patch
  set occupied 0
end

to delete_household
  ask turtles-here [die]
  clear_patch
end

to copy_household
  let tempid 0
  set currenthouse currenthouse + 1
  set tempid originalID
  ;show "tempid"
  ;show tempid
  ask one-of patches with [pcase = 0] [
    read_expenditures
    set pcase currenthouse
    set originalID tempid
    set occupied 1
    set used 0
  ]
end

to copy_turtles
  ask turtles-here [
    hatch 1 [
      set color white
      move-to one-of patches with [pcase = currenthouse]
      set homex pxcor          ; initialise original address
      set homey pycor          ; initialise original address      
    ]
  ]
end

to findparents          ; record id of parent
  let tempid 0         ; not set to 0 because household 1 would gain all unplaced agents
  let tempage 0
  let r 0.0
  set r random-float 1
  
  if r < 0.9 [                                              ; female is responsible for children
    ask patches with [count turtles-here > 0] [             ; for each household
      ask turtles-here [                                    ; for each occupant
        set tempid 0
        set tempage age
        if any? turtles-here with [sex = "female" and age > tempage + 16 and age < tempage + 40]        ; identify female parent
        [
          ask one-of turtles-here with [sex = "female" and age > tempage + 16 and age < tempage + 40] [set tempid who]  ; get parents id
        ]  
        set parentid tempid  ; remember parents id
      ]
    ]
  ]
  
  if r >= 0.9 [                                            ; male is responsible for children
    ask patches with [count turtles-here > 0] [            ; for each household
      ask turtles-here [                                   ; for each occupant
        set tempid 0
        set tempage age
        if any? turtles-here with [sex = "male" and age > tempage + 16 and age < tempage + 40]        ; identify male parent
        [
        ask one-of turtles-here with [sex = "male" and age > tempage + 16 and age < tempage + 40] [set tempid who]  ; get parents id
        ]  
        set parentid tempid  ; remember parents id
      ]
    ]
  ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;control routines
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to go         
  profiler:start                   ; main loop
  if years = stop_after [
    profiler:stop
    output-print profiler:report
    profiler:reset
    stop
  ]
  set current_year current_year + 1
  set years years + 1  ; increment calender
  show "----- new year begins -----"

  ask turtles [set incomechange false]
  ask patches [set incchange false set used 0]
  ask patches [set older false]

  set births 0
  set deaths 0
  
  if alignment = true [
    if current_year <= 2030 [set mortality_rate mortality_rate - (0.035 * mortality_rate)]
    ;show mortality_rate
  
    if current_year = 2006 [set birth_rate birth_rate + ((3.53 / 100) * birth_rate)]
    if current_year = 2007 [set birth_rate birth_rate + ((3.17 / 100) * birth_rate)]
    if current_year = 2008 [set birth_rate birth_rate + ((2.83 / 100) * birth_rate)]
    if current_year = 2009 [set birth_rate birth_rate + ((-0.59 / 100) * birth_rate)]
    if current_year = 2010 [set birth_rate birth_rate + ((1.73 / 100) * birth_rate)]
    if current_year = 2011 [set birth_rate birth_rate + ((0.82 / 100) * birth_rate)]
    if current_year = 2012 [set birth_rate birth_rate + ((0.96 / 100) * birth_rate)]
    if current_year = 2013 [set birth_rate birth_rate + ((0.08 / 100) * birth_rate)]
    if current_year = 2014 [set birth_rate birth_rate + ((-0.63 / 100) * birth_rate)]
    if current_year = 2015 [set birth_rate birth_rate + ((-0.99 / 100) * birth_rate)]
    if current_year = 2016 [set birth_rate birth_rate + ((-1.05 / 100) * birth_rate)]
    if current_year = 2017 [set birth_rate birth_rate + ((-1.09 / 100) * birth_rate)]
    if current_year = 2018 [set birth_rate birth_rate + ((-0.97 / 100) * birth_rate)]
    if current_year = 2019 [set birth_rate birth_rate + ((-0.69 / 100) * birth_rate)]
    if current_year = 2020 [set birth_rate birth_rate + ((-0.53 / 100) * birth_rate)]
    if current_year = 2021 [set birth_rate birth_rate + ((-0.5 / 100) * birth_rate)]
    if current_year = 2022 [set birth_rate birth_rate + ((-0.47 / 100) * birth_rate)]
    if current_year = 2023 [set birth_rate birth_rate + ((-0.46 / 100) * birth_rate)]
    if current_year = 2024 [set birth_rate birth_rate + ((-0.45 / 100) * birth_rate)]
    if current_year = 2025 [set birth_rate birth_rate + ((-0.44 / 100) * birth_rate)]
    if current_year = 2026 [set birth_rate birth_rate + ((-0.4 / 100) * birth_rate)]
    if current_year = 2027 [set birth_rate birth_rate + ((-0.25 / 100) * birth_rate)]
    if current_year = 2028 [set birth_rate birth_rate + ((-0.07 / 100) * birth_rate)]
  ]                  
  set startpopulation count turtles
  
  if demographics = true [             ; run demographic section
    ask turtles [updatedemographics]
    followparent
    returnhome
    returnhomeall
    clear_patches                ; mark empty patches as unoccupied
    occupy_patches               ; mark occupied households 
    reclassify_households  ; assign a type for all households to identify those which have changed demographically
    set_hrp_class          ; set household class to that of the highest individual occupant
    set_culture            ; estimate cultural capital of all households from the highest age left full time education of occupants
       
    initialise_temp_expenditures    ; update all temporary expenditures because they are used in update expenditures and change_expenditures to control the household updating process
    impute_income_and_expenditures          ; reset income and expenditures for households that have changed demographically
    change_expenditures
    show "no inc"
    show count patches with [incanon <= 0 and occupied = 1]
    show "lowest incomes"
    show min [incanon] of patches with [occupied = 1]
    show min [ptempincanon] of patches with [occupied = 1]     
    show "empty households after reclassification"
    show count patches with [incanon <= 0 and occupied = 1]
  ]

  ; income change section
  set mean_population_income mean [incanon] of patches with [occupied = 1]
  ;show "income change"
  ;show change_in_real_income%
  set target_mean_population_income mean_population_income + mean_population_income * (change_in_real_income% / 100)

  ask patches [
    if any? turtles-here [
      calculateexpenditures    ; find new expenditures 
    ]
  ]
  set changeeffective 1
  update_expenditures          ; detect changed household income and update expenditures from another patch of the same demographic type
  change_expenditures
  summarise
  show "households occupied"
  show count patches with [occupied = 1]
  show "households active"
  show count patches with [count turtles-here > 0]
  show "Total Income"
  show sum [incanon] of patches with [occupied = 1]
  outputexpenditures
  if years = 0 [write_file]
  if years = 5 [write_file]
  if years = 10 [write_file]
  if years = 15 [write_file]
  if years = 20 [write_file]
  if years = 25 [write_file]  
  if years = 30 [write_file]  
  if years mod 5 = 0 [
    show "Year "
    show current_year
    outputexpenditures
    showtypechanges        ; verification of allocation of expenditures when households change type
    showagechanges         ; monitor age groups
  ]  
  update-plot
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; demographic modules
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to updatedemographics
  let r 0.0
  set r random-float 1
  set currentagent who
  set newlyseparated 0
  set newcohabit 0
  set newwidow 0
  set newbirth 0
  
  terminate
  create
  if student = 1 [educate]             ; education module  
  leavehome

  ; partnership dissolution modules 
  set r random-float 1  ; decide whether male or female dominated this time through
  if r < 0.5 [  
    if sex = "male" and age >= 16 and age <= 69 and status = "married" [marriagedism]
  ]
  if r >= 0.5 [
    if sex = "female" and age >= 16 and age <= 69 and status = "married" [marriagedisf] 
  ]
  if r < 0.5 [
    if sex = "male" and age >= 16 and age <= 69 and status = "cohabiting" [cohabdism]  
  ]
  if r >= 0.5 [  
    if sex = "female" and age >= 16 and age <= 69 and status = "cohabiting" [cohabdisf]
  ]
  
  set myage age         ; marriage and cohabitation modules  

  if r < 0.5 [
    if sex = "male" and age >= 16 and age <= 69 and newwidow = 0 and status != "married" and status != "cohabiting" [cohabitm]  
  ]
  if r >= 0.5 [  
    if sex = "female" and age >= 16 and age <= 69 and newwidow = 0 and status != "married" and status != "cohabiting" [cohabitf]
  ]

  if r < 0.5 [
    if sex = "male" and age >= 16 and age <= 69 and status = "cohabiting" and newcohabit = 0 [marrycohabm]
    if sex = "male" and age >= 16 and age <= 69 and newwidow = 0
      and status != "married" and newlyseparated != 1 and changed = 0 and status != "cohabiting" [marrym]
  ]
  if r >= 0.5 [
    if sex = "female" and age >= 16 and age <= 69 and status = "cohabiting" and newcohabit = 0 [marrycohabf]
    if sex = "female" and age >= 16 and age <= 69 and newwidow = 0
      and status != "married" and newlyseparated != 1 and changed = 0 and status != "cohabiting" [marryf] 
  ]
  
  set age age + 1
  setagebands           ; update age groups
  if age >= 65 [set employment "Retired" set incomechange true]
  set r random-float 1
  if status = "separated" and r < 0.193 [set status "divorced" set previousstatus "divorced"]
  set r random-float 1
  if status = "separated" and r < 0.025 [set status "single" set previousstatus "divorced"]  
end

to terminate ; mortality module
  let r 0.0  ; random number 0 to 1 uniform distribution
  let p 0.0  ; probability of death in current year
  set r random-float 1
  
  if sex = "male" and age <= 40 [set p 0.000736]
  if sex = "male" and age > 40 [set p 0.00003 * (e ^ (0.0954 * age))] 
  
  if sex = "female" and age <= 40 [set p 0.000411]
  if sex ="female" and age > 40 [set p 0.00001 * (e ^ (0.1017 * age))]
  if p > 0.5 [set p 0.5]
  set p p * mortality_rate
  if r < p [
    if sex = "male" [
      ask turtles-here with [sex = "female" and status = "married"] 
        [set previousstatus "married" set status "widowed" set newwidow 1 set color brown] 
    ]
    if sex = "female" [
      ask turtles-here with [sex = "male" and status = "married"] 
        [set previousstatus "married" set status "widowed" set newwidow 1 set color gray] 
    ]
  set deaths deaths + 1     
  die
  ]
end

to educate  ; education module
  let r 0.0
  let emp 0.0
  set emp random-float 1
  if age = 16 and r < 0.234 [
    set student 0
    set education age
    set employment "Employed"
    if emp < 0.05 [set employment "Unemployed"]
    set myclass parentsclass
    set incomechange true
  ]
  if age = 17 and r < 0.3 [
    set student 0
    set education age 
    set employment "Employed"
    if emp < 0.05 [set employment "Unemployed"]    
    set myclass parentsclass
    set incomechange true    
  ]
  if age = 18 and r < 0.297 [
    set student 0 
    set education age 
    set employment "Employed"
    if emp < 0.05 [set employment "Unemployed"]    
    set myclass parentsclass
    set incomechange true    
  ]
  if age = 19 and r < 0.3 [ 
    set student 0 
    set education age 
    set employment "Employed" 
    if emp < 0.05 [set employment "Unemployed"]    
    set myclass parentsclass
    set incomechange true    
  ]
  if age = 20 and r < 0.193 [
    set student 0 
    set education age 
    set employment "Employed" 
    if emp < 0.05 [set employment "Unemployed"]    
    set myclass parentsclass
    set incomechange true    
  ]
  if age = 21 and r < 0.028 [ 
    set student 0 
    set education age 
    set employment "Employed"
    if emp < 0.05 [set employment "Unemployed"]     
    set myclass parentsclass
    set incomechange true    
  ]
  if age >= 22 [
    set student 0 
    set education age 
    set employment "Employed"
    if emp < 0.05 [set employment "Unemployed"]     
    set myclass parentsclass
    set incomechange true    
  ]
end

to create  ; fertility module
  let r 0.0
  let youngest 0   ; age of the youndest child
  let logit 0.0    ; logistic regression based on age, number of childrean and age of youngest child
  let p 0.0
  set r random-float 1
  if sex = "female" and age >= 15 and age <= 60 [
    set youngest min [age] of turtles-here
    
    if status = "married" [
      set logit 2.875 + (-0.155 * age) + (-0.264 * children) + (-0.002 * youngest)
      set p 1 / (1 + e ^ (-(logit)))
      set p p * birth_rate
      
      if r < p [
        set color yellow
        birth     ; generate one offspring
        mb        ; test for multiple births
      ]  
    ]
    if status = "cohabiting" [
      set logit -0.44 + (-0.078 * age) + (0.168 * children) + (0.01 * youngest)
      set p 1 / (1 + e ^ (-(logit)))
        set p p * birth_rate
      
      if r < p [
        set color yellow
        birth 
        mb
      ]  
    ]    
    if status = "single" or status = "divorced" or status = "widowed" or status = "separated" [
      set logit -3.192 + (-0.031 * age) + (0.466 * children) + (-0.021 * youngest)
      set p 1 / (1 + e ^ (-(logit)))
        set p p * birth_rate
      
      if r < p [
        set color yellow
        set r random-float 1
        if r < 0.8 and count turtles-here > 1 [move-to one-of patches with [not any? turtles-here]]
        birth
        mb
      ]  
    ]    
  ]  
end

to birth                 ; generate a new agent
  let r 0.0
  set r random-float 1
  set children children + 1
  set births births + 1
  set newbirth 1
  let l myclass


  hatch 1 [
    set age 0
    setagebands
    set status "single"
    set previousstatus "single"
    set parentid currentagent
    set parentsclass l
    set children 0
    set student 1
    set myclass 10
    set education 0
    set heading heading + 23
    set r random-float 1
    if r < 0.488 [set sex "female" set color pink]
    if r >= 0.488 [set sex "male" set color blue]
    set color white
    set homex pxcor
    set homey pycor
  ]
end

to mb  ; probability of a multiple birth
  let r 0.0
  set r random-float 1
  if age <= 19 and r < 0.00626 [birth]    ; test for twins
  if age >= 20 and age <= 24 and r < 0.00861 [birth]
  if age >= 25 and age <= 29 and r < 0.01177 [birth]
  if age >= 30 and age <= 34 and r < 0.01510 [birth]
  if age >= 35 and r < 0.01767 [birth]

  if age >= 20 and age <= 24 and r < 0.00009 [birth]  ; triplets
  if age >= 25 and age <= 29 and r < 0.00024 [birth]
  if age >= 30 and age <= 34 and r < 0.00068 [birth]
  if age >= 35 and r < 0.00085 [birth]
end

to leavehome
  let r 0.0
  set r random-float 1
  countdependents
  if count turtles-here > 1 and age >= 18 and status = "single" and numdependents = 0 and r < 0.1 [
    move-to one-of patches with [not any? turtles-here]
  ]
  if count turtles-here > 1 and age >= 25 and status = "single" and numdependents = 0 and r < 0.2 [
    move-to one-of patches with [not any? turtles-here]
  ]
  if count turtles-here > 1 and age >= 19 and status = "single" and education = 1 and  numdependents = 0 and r < 0.7 [
    move-to one-of patches with [not any? turtles-here]    ; university students living away from parental home
  ]
end

to countdependents
  let tempid 0
  set tempid who
  set numdependents count turtles-here with [parentid = tempid]
end

to marrycohabm         ; probability of marrying cohabitee for males
  let r 0.0
  let p 0.0
  let logit 0.0
  set r random-float 1
    
  set logit -1.807 + (-0.015 * thirties) + (-0.541 * forties) + (-1.001 * fifties) + (-0.829 * sixties)                          
  set p 1 / (1 + e ^ (-(logit)))      ; probability of marrying cohabitee                                                 
  set p p * propensity_to_marry
  if r < p [
    if any? turtles-here with [        ; check female is present
      sex = "female"
      and status = "cohabiting"
      and changed = 0
    ] [
      set color green
      set previousstatus status
      set status "married"
      set mm mm + 1
      set fm fm + 1
      ask one-of turtles-here with [
        sex = "female" 
        and status = "cohabiting"
        and changed = 0
      ] [
        set color green
        set previousstatus status
        set status "married"
      ]
    ]
  ]
end

to marrycohabf        ; probability of marrying cohabitee for females
  let r 0.0
  let p 0.0
  let logit 0.0
  set r random-float 1
    
  set logit -1.862 + (-0.126 * thirties) + (-0.121 * forties) + (-0.708 * fifties) + (-1.113 * sixties)
  set p 1 / (1 + e ^ (-(logit)))      ; probability of marrying cohabitee
  set p p * propensity_to_marry
  
  if r < p [
    if any? turtles-here with [        ; check female is present
      sex = "male"
      and status = "cohabiting"
      and changed = 0
    ] [
      set color green
      set previousstatus status
      set status "married"
      set mm mm + 1
      set fm fm + 1 
      ask one-of turtles-here with [
        sex = "male" 
        and status = "cohabiting"
        and changed = 0
      ] [
        set color green
        set previousstatus status
        set status "married"
      ]
    ]   
  ]
end

to marrym
  let p 0.0        ; probability of marriage for males
  let t 0          ; turtle number
  let r 0.0        ; random number
  let w 0          ; widowed
  let d 0          ; divorced
  let s 0          ; separated
  let logit 0.0    ; logistic regression based on age and marital status
  let found 0      ; located partner on this pass
  
  if status = "widowed" [set w 1]
  if status = "divorced" [set d 1]
  if status = "separated" [set s 1]
  
  set r random-float 1
  if not any? turtles with [
    sex = "female"              ; check if there is anyone available
    and status != "married"
    and status != "cohabiting"
    and newlyseparated != 1
    and age >= 16
    and changed = 0             ; did not separate from cohabitation in the current years dissolution module
    and age > (myage - 15)
    and age < (myage + 15)] [
      show "No agent found" stop
  ]
    
  set logit -4.207 + (-0.001 * age) + (0.137 * w) + (0.692 * d) + (1.684 * s)
  set p 1 / (1 + e ^ (-(logit)))                                                      
  set p p * propensity_to_marry
  
  if r < p [
    setlimitsm
    set previousstatus status 
    set status "married"
    set mm mm + 1
    set fm fm + 1
    set color violet
    set t who
    move-to one-of patches with [not any? turtles-here]
      
    if any? turtles with [          ; seek male of suitable age
      sex = "female"
      and status != "married"
      and status != "cohabiting"
      and newlyseparated != 1
      and age >= 16
      and changed = 0
      and age >= (myage + lower)
      and age <= (myage + upper)
    ] [  
    set found 1
      ask one-of turtles with [
        sex = "female" 
        and status != "married"
        and status != "cohabiting"
        and newlyseparated != 1
        and age >= 16
        and changed = 0
        and age >= (myage + lower)
        and age <= (myage + upper)
      ] [
        move-to turtle t
        set color green
        set previousstatus status
        set status "married"
      ]   
    ]   

    if found = 0 [              ; widen age range
      ask one-of turtles with [
        sex = "female" 
        and status != "married"
        and status != "cohabiting"
        and newlyseparated != 1
        and age >= 16
        and changed = 0
        and age > (myage - 15)
        and age < (myage + 15)
      ] [
        move-to turtle t
        set color green
        set previousstatus status
        set status "married"
      ]
    ]
  ]
end

to marryf
  let p 0.0        ; probability of marriage for females
  let t 0          ; turtle number
  let r 0.0        ; random number
  let w 0          ; widowed
  let d 0          ; divorced
  let s 0          ; separated
  let logit 0.0    ; logistic regression based on age and marital status
  let found 0      ; located partner on this pass
  
  if status = "widowed" [set w 1]
  if status = "divorced" [set d 1]
  if status = "separated" [set s 1]
  
  set r random-float 1
  if not any? turtles with [
    sex = "male"              ; check if there is anyone available
    and status != "married"
    and status != "cohabiting"
    and newlyseparated != 1
    and age >= 16
    and changed = 0
    and age > (myage - 15)
    and age < (myage + 15)] [
      show "No agent found" stop
  ]
    
  set logit -3.408 + (-0.028 * age) + (0.172 * w) + (0.686 * d) + (2.1 * s) + (0.644 * newbirth)                          
  set p 1 / (1 + e ^ (-(logit)))                                                      
  set p p * propensity_to_marry
               
  if r < p [
    setlimitsf
    set previousstatus status     
    set status "married"
    set fm fm + 1
    set mm mm + 1
  
    set color violet
    set t who
    move-to one-of patches with [not any? turtles-here]
      
    if any? turtles with [          ; seek male of suitable age
      sex = "male"
      and status != "married"
      and status != "cohabiting"
      and newlyseparated != 1
      and age >= 16
      and changed = 0
      and age >= (myage + lower)
      and age <= (myage + upper)
    ] [  
    set found 1
    ask one-of turtles with [
      sex = "male" 
      and status != "married"
      and status != "cohabiting"
      and newlyseparated != 1
      and age >= 16
      and changed = 0
      and age >= (myage + lower)
      and age <= (myage + upper)
    ] [
      move-to turtle t
      set color green
      set previousstatus status
      set status "married"
      ]   
    ]   
      
    if found = 0 [              ; widen age range
      ask one-of turtles with [
        sex = "male" 
        and status != "married"
        and status != "cohabiting"
        and newlyseparated != 1
        and age >= 16
        and changed = 0
        and age > (myage - 15)
        and age < (myage + 15)
        ] [
        move-to turtle t
        set color green
        set previousstatus status        
        set status "married"
      ]
    ]
  ]
end

to cohabitm
  let p 0.0        ; probability of cohabitation for males
  let t 0          ; turtle number
  let r 0.0        ; random number
  let w 0          ; widowed
  let d 0          ; divorced
  let s 0          ; separated
  let logit 0.0    ; logistic regression based on age and marital status
  let found 0      ; located partner on this pass
  
  if status = "widowed" [set w 1]
  if status = "divorced" [set d 1]
  if status = "separated" [set s 1]
  
  set r random-float 1
  if not any? turtles with [
    sex = "female"              ; check if there is anyone available
    and status != "married"
    and status != "cohabiting"
    and age >= 16
    and age > (myage - 20)
    and age < (myage + 20)] [
      show "No agent found" stop
  ]
    
  set logit -2.199 + (-0.021 * age) + (-0.033 * w) + (0.67 * d) + (1.21 * s)                          
  set p 1 / (1 + e ^ (-(logit)))                                                      
  set p p * propensity_to_cohabit
  
  if r < p [
    setlimitsm
    set previousstatus status  ; store old marital status
    set status "cohabiting"
    set newcohabit 1
    set fc fc + 1
    set mc mc + 1
    set color violet
    set t who
    move-to one-of patches with [not any? turtles-here]
      
    if any? turtles with [          ; seek female of suitable age
      sex = "female"
      and status != "married"
      and status != "cohabiting"
      and age >= 16
      and age >= (myage + lower)
      and age <= (myage + upper)
    ] [  
    set found 1
      ask one-of turtles with [
        sex = "female" 
        and status != "married"
        and status != "cohabiting"
        and age >= 16
        and age >= (myage + lower)
        and age <= (myage + upper)
      ] [
      move-to turtle t
      set color green
      set previousstatus status      
      set status "cohabiting"
      set newcohabit 1
      ]   
    ]   
      
    if found = 0 [              ; widen age range
      ask one-of turtles with [
        sex = "female" 
        and status != "married"
        and status != "cohabiting"
        and age >= 16
        and age > (myage - 20)
        and age < (myage + 20)
        ] [
        move-to turtle t
        set color green
        set previousstatus status    
        set status "cohabiting"
        set newcohabit 1
      ]
    ]
  ]
end

to cohabitf
  let p 0.0        ; probability of cohabiting for females
  let t 0          ; turtle number
  let r 0.0        ; random number
  let w 0          ; widowed
  let d 0          ; divorced
  let s 0          ; separated
  let logit 0.0    ; logistic regression based on age, marital status and birth from fertility module
  let found 0      ; located partner on this pass
  
  if status = "widowed" [set w 1]
  if status = "divorced" [set d 1]
  if status = "separated" [set s 1]
  
  set r random-float 1
  if not any? turtles with [
    sex = "male"              ; check if there is anyone available
    and status != "married"
    and status != "cohabiting"
    and age >= 16
    and age > (myage - 20)
    and age < (myage + 20)] [
      show "No agent found" stop
  ]
    
  set logit -1.357 + (-0.045 * age) + (-0.69 * w) + (0.536 * d) + (0.478 * s) + (0.757 * newbirth)                          
  set p 1 / (1 + e ^ (-(logit)))                                                      
  set p p * propensity_to_cohabit
                 
  if r < p [
    setlimitsf
    set previousstatus status   
    set status "cohabiting"
    set newcohabit 1
    set mc mc + 1
    set fc fc + 1
    set color violet
    set t who
    move-to one-of patches with [not any? turtles-here]
      
    if any? turtles with [          ; seek male of suitable age
      sex = "male"
      and status != "married"
      and status != "cohabiting"
      and age >= 16
      and age >= (myage + lower)
      and age <= (myage + upper)
    ] [  
    set found 1
      ask one-of turtles with [
        sex = "male" 
        and status != "married"
        and status != "cohabiting"
        and age >= 16
        and age >= (myage + lower)
        and age <= (myage + upper)
      ] [
      move-to turtle t
      set color green
      set previousstatus status     
      set status "cohabiting"
      set newcohabit 1
      ]   
    ]   
      
    if found = 0 [              ; widen age range
      ask one-of turtles with [
        sex = "male" 
        and status != "married"
        and status != "cohabiting"
        and age >= 16
        and age > (myage - 20)
        and age < (myage + 20)
        ] [
        move-to turtle t
        set color green
        set previousstatus status
        set status "cohabiting"
        set newcohabit 1
      ]
    ]
  ]
end

to marriagedism
  let p 0.0  ; probability of separation from marriage for males
  let r 0.0
  let x 0
  let y 0
  let logit 0.0 ; logistic regression model depending on ageband
  set r random-float 1
  
  set logit -3.112 + (-0.627 * thirties) + (-0.954 * forties) + (-1.848 * fifties) + (-3.078 * sixties)
  set p 1 / (1 + e ^ (-(logit)))                                                      
  set p p * propensity_to_divorce
  
  if r < p [
    if any? turtles-here with [sex = "female" and status = "married"] [
      set r random-float 1        ; decide which agent moves out 
      set mms mms + 1
      set fms fms + 1   
      ask one-of turtles-here with [sex = "female" and status = "married"] [
        set color red
        set status "separated" ; change leavers marital status to separated
        set previousstatus "married"
        set newlyseparated 1
        if r <= 0.1 [
          move-to one-of patches with [not any? turtles-here]       ; female moves out
        ]
      ]
      set status "separated"   ; current agent marital status set to separated
      set previousstatus "married"
      set newlyseparated 1
      set color orange
      if r > 0.1 [
        move-to one-of patches with [not any? turtles-here]          ; male moves out
      ]   
    ]
  ] 
end

to marriagedisf
  let p 0.0  ; probability of separation from marriage for females
  let r 0.0
  let x 0
  let y 0
  let logit 0.0 ; logistic regression model depending on ageband and birth from the fertility module
  set r random-float 1
  
  set logit -2.947 + (-1.134 * newbirth) + (-0.503 * thirties) + (-1.036 * forties) + (-1.938 * fifties) + (-3.378 * sixties)                          
  set p 1 / (1 + e ^ (-(logit)))                                                      
  set p p * propensity_to_divorce
  
  if r < p [
    if any? turtles-here with [sex = "male" and status = "married"] [
      set r random-float 1        ; decide which agent moves out
      set fms fms + 1 
      set mms mms + 1   
      ask one-of turtles-here with [sex = "male" and status = "married"] [
        set color red
        set status "separated" ; change leavers marital status divorced
        set previousstatus "married"
        set newlyseparated 1
        if r < 0.9 [
          move-to one-of patches with [not any? turtles-here]    ; male moves out
        ]
      ]
      set status "separated"   ; current agent marital status set to divorced
      set previousstatus "married"
      set newlyseparated 1
      set color orange
      if r >= 0.9 [   
        move-to one-of patches with [not any? turtles-here]      ; female moves out
      ]   
    ]
  ] 
end

to cohabdism
  let p 0.0  ; probability of separation from cohabitation for males
  let r 0.0
  let x 0
  let y 0
  let logit 0.0 ; logistic regression model depending on ageband
  set r random-float 1
  
  set logit -1.932 + (-0.671 * thirties) + (-1.438 * forties) + (-0.611 * fifties) + (-2.064 * sixties)                          
  set p 1 / (1 + e ^ (-(logit)))                                                      
  set p p * propensity_to_split
  
  if r < p [
    if any? turtles-here with [sex = "female" and status = "cohabiting"] [
      set r random-float 1        ; decide which agent moves out
      set mcs mcs + 1
      set fcs fcs + 1    
      ask one-of turtles-here with [sex = "female" and status = "cohabiting"] [
        set color red
        set status previousstatus ; change leavers marital status to what it was before
        set previousstatus "cohabiting"
        set changed 1
        if r <= 0.1 [  
          move-to one-of patches with [not any? turtles-here]    ; female moves out  
        ]
      ]
      set status previousstatus   ; current agent reverts to previous marital status
      set previousstatus "cohabiting"
      set changed 1
      set color orange
      if r > 0.1 [
        move-to one-of patches with [not any? turtles-here]     ; male moves out
      ]   
    ]
  ] 
end

to cohabdisf
  let p 0.0  ; probability of separation from cohabitation for females
  let r 0.0
  let x 0
  let y 0
  let logit 0.0 ; logistic regression model depending on ageband and birth from the fertility module
  set r random-float 1
  
  set logit -1.923 + (-0.526 * newbirth) + (-0.523 * thirties) + (-0.898 * forties) + (-1.115 * fifties) + (-1.197 * sixties)                          
  set p 1 / (1 + e ^ (-(logit)))                                                      
  set p p * propensity_to_split
  
  if r < p [
    if any? turtles-here with [sex = "male" and status = "cohabiting"] [
      set r random-float 1        ; decide which agent moves out
      set fcs fcs + 1
      set mcs mcs + 1    
      ask one-of turtles-here with [sex = "male" and status = "cohabiting"] [
        set color red
        set status previousstatus ; change leavers marital status to what it was before
        set previousstatus "cohabiting"
        set changed 1
        if r < 0.9 [
          move-to one-of patches with [not any? turtles-here]     ; male moves out       
        ]
      ]
      set status previousstatus   ; current agent reverts to previous marital status
      set previousstatus "cohabiting"
      set changed 1
      set color orange
      if r >= 0.9 [
        move-to one-of patches with [not any? turtles-here]      ; female moves out
      ]   
    ]
  ] 
end

to returnhome
  let x 0
  let y 0
  let r 0.0
  ask turtles [
    if count turtles-here = 1 [
    set r random-float 1
    if r < 0.5 [
      countdependents
      let tempid 0
      set tempid parentid
      if numdependents = 0
        and (changed = 1 or newlyseparated = 1)
        and age < 25
        and status != "married"
        and status != "cohabiting" [
          if any? turtles with [who = tempid] [move-to turtle parentid stop]]
        set x homex
        set y homey
        move-to one-of patches with [pxcor = x and pycor = y]
      ]  
    ]
  ]
end

to returnhomeall
  let x 0
  let y 0
  let r 0.0
  
  ask turtles [
    set r random-float 1
    if r < 0.01 and (count turtles-here = 1) [
      let tempid 0
      set tempid parentid
      if parentid > 0
        and status != "married"
        and status != "cohabiting" [
        if any? turtles with [who = tempid] [move-to turtle parentid stop]]
    set x homex
    set y homey
    move-to one-of patches with [pxcor = x and pycor = y]
    ]
  ]
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; expenditure modules
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to initial_household_classification                          ; assign initial household type based on demographic parameters only
  ask patches with [count turtles-here > 0] [
    set lasttype currenttype
    set numoccupants count turtles-here
    set_household_age_bands
    set currenttype 6  ; other households
    set_household_type
    set lasttype currenttype  ; set initial type to avoid being included in impute income module
    set oldnumoccupants numoccupants
    set oldhouseageband houseageband
    set oldest max [age] of turtles-here
  ]    
end

to reclassify_households        ; set type for all occupied households
  let t 0
  ask patches with [occupied = 1] [
    set lasttype currenttype
    set oldnumoccupants numoccupants
    set oldhouseageband houseageband    
    set numoccupants count turtles-here
    if numoccupants != oldnumoccupants [set incchange true]
    set_household_age_bands
    if houseageband != oldhouseageband [set older true]
    set older true    ; ageband in incremented every year and overrides ten year bands in this version
    set_household_type
    set oldest max [age] of turtles-here
  ]
end

to set_household_type
  set currenttype 6
  if count turtles-here = 1 and count turtles-here with [sex = "male"] = 1 and
    max[age] of turtles-here < 65 [set currenttype 1]                                      ; single non pensionable
  if count turtles-here = 1 and count turtles-here with [sex = "female"] = 1 and
    max[age] of turtles-here < 60 [set currenttype 1]                                      ; single non pensionable

  if count turtles-here = 1 and count turtles-here with [sex = "male"] = 1 and
    min[age] of turtles-here >= 65 [set currenttype 2]                                     ; single pensionable
  if count turtles-here = 1 and count turtles-here with [sex = "female"] = 1 and
     min[age] of turtles-here >= 60 [set currenttype 2]                                    ; single pensionable
      
  if count turtles-here = 2 and count turtles-here with [age < 16] = 0 [set currenttype 3] ; 2 adults
    
  let nk 0
  set nk count turtles-here with [age < 16] ; count under 16s
  if nk >= 1 and count turtles-here = nk + 2 [set currenttype 4]                           ; 2 adults + children
    
  set nk count turtles-here with [age < 16] ; count under 16s
  if nk >= 1 and count turtles-here = nk + 1 [set currenttype 5]                           ; 1 adult + children
end

to impute_income_and_expenditures
  let copytype 0     ; method of copying depending on similarity of available households to current households
  let t 0            ; current household type
  let n 0            ; number of people in the household
  let o 0            ; age of the oldest household member
  let ag 0           ; age decade of oldest household member
  let sec 0          ; temporary storage for class of hrp
  let cul 0          ; temporary storage for household educational level
  ask patches with [occupied = 1 and (incanon <= 1 or older = true or lasttype != currenttype or numoccupants != oldnumoccupants)] [
    set copytype 0
    set t currenttype
    set n numoccupants
    set o oldest
    set ag houseageband 
    set sec class
    set cul culture            
    if any? other patches with [occupied = 1 and incanon > 1] [
      set copytype 1
    ]
    if any? other patches with [occupied = 1 and incanon > 1 and houseageband = ag] [
      set copytype 2
    ]   
    if any? other patches with [occupied = 1 and incanon > 1 and (oldest - 1) = o] [
      set copytype 3
    ]
    if any? other patches with [occupied = 1 and incanon > 1 and (oldest - 1) = o and currenttype = lasttype and currenttype = t
                                                                      and numoccupants = n and numoccupants = oldnumoccupants] [
      set copytype 4
    ]

    if copytype = 1 [
      ask one-of other patches with [
        occupied = 1 and incanon > 1
      ] [store_expenditures]
      read_temp_expenditures
    ]
    if copytype = 2 [
      ask one-of other patches with [
        occupied = 1 and incanon > 1 and houseageband = ag
      ] [store_expenditures]
      read_temp_expenditures
    ]
    if copytype = 3 [
      ask one-of other patches with [
        occupied = 1 and incanon > 1 and (oldest - 1) = o
      ] [store_expenditures]
      read_temp_expenditures
    ] 
    if copytype = 4 [
      ask one-of other patches with [
        occupied = 1 and incanon > 1 and (oldest - 1) = o and currenttype = t and currenttype = lasttype
                                              and numoccupants = n and numoccupants = oldnumoccupants
      ] [store_expenditures]
      read_temp_expenditures
    ]
    set effectiveincome incanon
    set targetincome incanon  
  ]
end

to impute_initial_income
  let copytype 0    ; method of copying depending on similarity of available households to current households
  let t 0           ; current household type
  let n 0           ; number of people in the household
  let o 0           ; age of oldest household member
  let ag 0          ; age decade of oldest household member  
  let sec 0         ; temporary storage for class of hrp
  let cul 0         ; temporary storage for household educational level
  ask patches with [occupied = 1 and (incanon <= 1 or older = true or lasttype != currenttype or numoccupants != oldnumoccupants)] [
    set copytype 0
    set t currenttype
    set n numoccupants
    set o oldest
    set ag houseageband
    set sec class
    set cul culture            
    if any? other patches with [occupied = 1 and incanon > 1] [
      set copytype 1
    ]
    if any? other patches with [occupied = 1 and incanon > 1 and houseageband = ag] [
      set copytype 2
    ]     
    if any? other patches with [occupied = 1 and incanon > 1 and oldest = o] [
      set copytype 3
    ]
    if any? other patches with [occupied = 1 and incanon > 1 and oldest = o and currenttype = t and numoccupants = n] [
      set copytype 4
    ]    
    
    if copytype = 1 [
      ask one-of other patches with [
        occupied = 1 and incanon > 1
      ] [store_expenditures]
      read_expenditures
    ]
    if copytype = 2 [
      ask one-of other patches with [
        occupied = 1 and incanon > 1 and houseageband = ag
      ] [store_expenditures]
      read_expenditures
    ]    
    if copytype = 3 [
      ask one-of other patches with [
        occupied = 1 and incanon > 1 and oldest = o
      ] [store_expenditures]
      read_expenditures
    ]
    if copytype = 4 [
      ask one-of other patches with [
        occupied = 1 and incanon > 1 and oldest = o and currenttype = t and numoccupants = n
      ] [store_expenditures]
      read_expenditures
    ]    
    set effectiveincome incanon
    set targetincome incanon  
  ]
end

to impute_missing_expenditures
  let t 0
  ask patches with ([count turtles-here >= 1 and food < 0]) [
    set t currenttype
    ask one-of patches with [currenttype = t] [store_expenditures]
    read_expenditures
  ]
end

to set_hrp_class                            ; reset the household class to the highest class of all occupants
  ask patches with [occupied = 1] [
    if any? turtles-here with [myclass = 0] [set class "Inactive"]
    if any? turtles-here with [myclass >= 9] [set class "Inactive"]
    if any? turtles-here with [myclass = 8] [set class "NS-SEC 8"]
    if any? turtles-here with [myclass = 7] [set class "NS-SEC 7"]
    if any? turtles-here with [myclass = 6] [set class "NS-SEC 6"]
    if any? turtles-here with [myclass = 5] [set class "NS-SEC 5"]
    if any? turtles-here with [myclass = 4] [set class "NS-SEC 4"]
    if any? turtles-here with [myclass = 3] [set class "NS-SEC 3"]
    if any? turtles-here with [myclass = 2] [set class "NS-SEC 2"]
    if any? turtles-here with [myclass = 1] [set class "NS-SEC 1"]
    
    if any? turtles-here with [sex = "male" and age >= 65] [set class "Retired"]
    if any? turtles-here with [sex = "female" and age >= 65] [set class "Retired"]
  ]
end

to calculateexpenditures                     ; update expenditure determinants for each patch
  set oldhhincome incanon
  set changes_pending false
  set targetincome incanon + incanon * (change_in_real_income% / 100)
  if targetincome <= 0 [set targetincome 70]  ; avoid negative incomes
  if oldhhincome < 0 [show "error"]
  set hhincome sum [apaygyr] of turtles-here
  if any? turtles-here with [incomechange = true] [set incchange true]
end

to set_culture                ; estimate cultural capital of households
  let ageleftfulltimeeducation 0
  ask patches with [occupied = 1] [   
    set ageleftfulltimeeducation max [neducation] of turtles-here
    if ageleftfulltimeeducation <= 16 [set culture "secondary"]
    if ageleftfulltimeeducation >= 17 and ageleftfulltimeeducation <= 18 [set culture "intermediate"]
    if ageleftfulltimeeducation >= 21 [set culture "university"]
  ]
end  

to update_expenditures    ; if state transition copy expenditures from another patch
  let t 0              ; household type
  let targ 0.0         ; household income after change
  let r 0.0            ; random number
  let copytype 0       ; type of household to copy from
  let cul 0            ; highest educational level in household
  let sec 0            ; class of hrp
  let keepgoing false  ; more households to process
  
  ask patches with [occupied = 1] [
    set keepgoing false    ; incomes and expenditures of households are updated until the population change in income
                           ; reaches the income change specified for all individuals
                           ; this is to prevent the simulation from over estimating changes in income and expenditure
                           ; which it would do because of the non-linear income distribution
    set mean_population_income mean [ptempincanon] of patches with [occupied = 1]
                           ; mean ptempincanon is used as a marker of current income changes because it stores
                           ; the income copied from the donor household. actual household incomes are updated in
                           ; the change_expenditures function 
    ;show "mean income"
    ;show mean_population_income
    ;show "target population income"
    ;show target_mean_population_income
    if change_in_real_income% > 0 [
      if mean_population_income < target_mean_population_income [set keepgoing true]
    ]
    if change_in_real_income% < 0 [
      if mean_population_income > target_mean_population_income [set keepgoing true]  
    ]
    if (incanon != targetincome and keepgoing = true) [
      set t currenttype
      set targ targetincome
      set sec class
      set cul culture
      set r random-float 1
      set copytype 0
      if r < 0.5 [
        if any? other patches with [currenttype = t and incanon >= targ and occupied = 1] [set copytype 2]
        if any? other patches with [currenttype = t and incanon >= targ and occupied = 1 and
          class = sec and culture = cul] [set copytype 3]
        if copytype = 2 [
         ask min-one-of other patches with [currenttype = t and incanon >= targ and occupied = 1] [incanon] [store_expenditures]
         read_temp_expenditures
        ]
        if copytype = 3 [
          ask min-one-of other patches with [currenttype = t and incanon >= targ and occupied = 1
            and class = sec and culture = cul] [incanon] [store_expenditures]
          read_temp_expenditures
        ]
        if copytype = 0 [
          vary_expenditures
        ]
      ]
      if r >= 0.5 [
         if any? other patches with [currenttype = t and incanon <= targ and occupied = 1] [set copytype 2]        
          if any? other patches with [currenttype = t and incanon <= targ and occupied = 1 and
            class = sec and culture = cul] [set copytype 3]
          if copytype = 2 [
            ask max-one-of other patches with [currenttype = t and incanon <= targ and occupied = 1] [incanon] [store_expenditures]
            read_temp_expenditures
          ]
          if copytype = 3 [
            ask max-one-of other patches with [currenttype = t and incanon <= targ and occupied = 1 and
              class = sec and culture = cul] [incanon] [store_expenditures]
            read_temp_expenditures
        ]
        if copytype = 0 [
          vary_expenditures
        ]
      ]
    ]  
  ]
end

to vary_effective  ; inflate or deflate all expenditures when there is no suitable household to copy from
  if oldeffectiveincome != 0 [
    set ptemptotalexpenditure totalexpenditure - (totalexpenditure * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempinternet internet - (internet * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempsaved saved - (saved * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptemptelecom telecom - (telecom * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempnontelecom nontelecom - (nontelecom * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempfood food - (food * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempalcohol alcohol - (alcohol * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempclothing clothing - (clothing * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptemphousing housing - (housing * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempfurniture furniture - (furniture * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptemphealth health - (health * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptemptransport transport - (transport * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempcommunication communication - (communication * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptemprecreation recreation - (recreation * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempeduc educ - (educ * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptemphotels hotels - (hotels * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempmisc misc - (misc * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
    set ptempotherexp otherexp - (otherexp * ((oldeffectiveincome - effectiveincome) / oldeffectiveincome))
  ]  
end

to vary_expenditures  ; inflate or deflate incomes and expenditures when there is no higher or lower income household to copy from
  if incanon != 0 [
    set changes_pending true
    set ptempincanon incanon - (incanon * ((incanon - targetincome) / incanon))
    set ptempeffectiveincome effectiveincome - (effectiveincome * ((incanon - targetincome) / incanon))
    set ptemptotalexpenditure totalexpenditure - (totalexpenditure * ((incanon - targetincome) / incanon))
    set ptempinternet internet - (internet * ((incanon - targetincome) / incanon))
    set ptempsaved saved - (saved * ((incanon - targetincome) / incanon))
    set ptemptelecom telecom - (telecom * ((incanon - targetincome) / incanon))
    set ptempnontelecom nontelecom - (nontelecom * ((incanon - targetincome) / incanon))
    set ptempfood food - (food * ((incanon - targetincome) / incanon))
    set ptempalcohol alcohol - (alcohol * ((incanon - targetincome) / incanon))
    set ptempclothing clothing - (clothing * ((incanon - targetincome) / incanon))
    set ptemphousing housing - (housing * ((incanon - targetincome) / incanon))
    set ptempfurniture furniture - (furniture * ((incanon - targetincome) / incanon))
    set ptemphealth health - (health * ((incanon - targetincome) / incanon))
    set ptemptransport transport - (transport * ((incanon - targetincome) / incanon))
    set ptempcommunication communication - ((communication * (incanon - targetincome) / incanon))
    set ptemprecreation recreation - (recreation * ((incanon - targetincome) / incanon))
    set ptempeduc educ - (educ * ((incanon - targetincome) / incanon))
    set ptemphotels hotels - (hotels * ((incanon - targetincome) / incanon))
    set ptempmisc misc - (misc * ((incanon - targetincome) / incanon))
    set ptempotherexp otherexp - (otherexp * ((incanon - targetincome) / incanon))
  ]  
end

to store_expenditures    ; record expenditures in global variables for copying to another patch
  set gtempincanon incanon
  if gtempincanon <= 0 [show "no income set in store expenditures"]
  set gtemptotalexpenditure totalexpenditure
  set gtempinternet internet
  set gtempsaved saved
  set gtemptelecom telecom
  set gtempnontelecom nontelecom
  set gtempeffectiveincome effectiveincome
  set gtempfood food
  set gtempalcohol alcohol
  set gtempclothing clothing
  set gtemphousing housing
  set gtempfurniture furniture
  set gtemphealth health
  set gtemptransport transport
  set gtempcommunication communication
  set gtemprecreation recreation
  set gtempeduc educ
  set gtemphotels hotels
  set gtempmisc misc
  set gtempotherexp otherexp
  set used 1
end

to read_temp_expenditures    ; read stored global budget shares into current patch temporary variables
  set changes_pending true
  set ptempincanon gtempincanon
  set ptemptotalexpenditure gtemptotalexpenditure
  set ptempinternet gtempinternet
  set ptempsaved gtempsaved
  set ptemptelecom gtemptelecom
  set ptempnontelecom gtempnontelecom
  set ptempeffectiveincome gtempeffectiveincome
  set ptempfood gtempfood
  set ptempalcohol gtempalcohol
  set ptempclothing gtempclothing
  set ptemphousing gtemphousing
  set ptempfurniture gtempfurniture
  set ptemphealth gtemphealth
  set ptemptransport gtemptransport
  set ptempcommunication gtempcommunication
  set ptemprecreation gtemprecreation
  set ptempeduc gtempeduc
  set ptemphotels gtemphotels
  set ptempmisc gtempmisc
  set ptempotherexp gtempotherexp
end

to read_expenditures    ; alter expenditures directly from global variable
  set totalexpenditure gtemptotalexpenditure
  set internet gtempinternet
  set incanon gtempincanon
  if incanon <= 0 [show "income 0 or less"]
  set saved gtempsaved
  set telecom gtemptelecom
  set nontelecom gtempnontelecom
  set effectiveincome gtempeffectiveincome
  set food gtempfood
  set alcohol gtempalcohol
  set clothing gtempclothing
  set housing gtemphousing
  set furniture gtempfurniture
  set health gtemphealth
  set transport gtemptransport
  set communication gtempcommunication
  set recreation gtemprecreation
  set educ gtempeduc
  set hotels gtemphotels
  set misc gtempmisc
  set otherexp gtempotherexp

  set ptemptotalexpenditure gtemptotalexpenditure
  set ptempinternet gtempinternet
  set ptempincanon gtempincanon
  set ptempsaved gtempsaved
  set ptemptelecom gtemptelecom
  set ptempnontelecom gtempnontelecom
  set ptempeffectiveincome gtempeffectiveincome
  set ptempfood gtempfood
  set ptempalcohol gtempalcohol
  set ptempclothing gtempclothing
  set ptemphousing gtemphousing
  set ptempfurniture gtempfurniture
  set ptemphealth gtemphealth
  set ptemptransport gtemptransport
  set ptempcommunication gtempcommunication
  set ptemprecreation gtemprecreation
  set ptempeduc gtempeduc
  set ptemphotels gtemphotels
  set ptempmisc gtempmisc
  set ptempotherexp gtempotherexp
end

to change_expenditures    ; alter expenditures from temporary patch variables after annual processing is completed
  ask patches with [occupied = 1 and changes_pending = true] [
    ;show "income before change expenditures"
    ;show incanon
    set incanon ptempincanon
    ;Show "income after"
    ;show incanon
    if incanon < 1 [set incanon 1 show "low income identified"]
    set totalexpenditure ptemptotalexpenditure
    set internet ptempinternet
    set saved ptempsaved
    set telecom ptemptelecom
    set nontelecom ptempnontelecom
    set effectiveincome ptempeffectiveincome
    if effectiveincome < 1 [set effectiveincome 1]
    set food ptempfood
    set alcohol ptempalcohol
    set clothing ptempclothing
    set housing ptemphousing
    set furniture ptempfurniture
    set health ptemphealth
    set transport ptemptransport
    set communication ptempcommunication
    set recreation ptemprecreation
    set educ ptempeduc
    set hotels ptemphotels
    set misc ptempmisc
    set otherexp ptempotherexp
  ]
end

to initialise_temp_expenditures    ; set up initial values in temporary patch variables
  ask patches with [occupied = 1] [
    set ptemptotalexpenditure totalexpenditure
    set ptempinternet internet
    set ptempincanon incanon
    set ptempsaved saved
    set ptemptelecom telecom
    set ptempnontelecom nontelecom
    set ptempeffectiveincome effectiveincome
    set ptempfood food
    set ptempalcohol alcohol
    set ptempclothing clothing
    set ptemphousing housing
    set ptempfurniture furniture
    set ptemphealth health
    set ptemptransport transport
    set ptempcommunication communication
    set ptemprecreation recreation
    set ptempeduc educ
    set ptemphotels hotels
    set ptempmisc misc
    set ptempotherexp otherexp
  ]  
end

to summarise                    ; set up global variables after annual cycle
  set pop count turtles
  if pop = 0 [stop]
  set houses count patches with [count turtles-here > 0]
  set h1 count patches with [count turtles-here = 1]
  set h1 (h1 / houses) * 100
  set h2 count patches with [count turtles-here = 2]
  set h2 (h2 / houses) * 100
  set h3 count patches with [count turtles-here = 3]
  set h3 (h3 / houses) * 100
  set h4 count patches with [count turtles-here >= 4]
  set h4 (h4 / houses) * 100
  set hsize (pop / houses)
  set meanage (sum [age] of turtles) / count turtles
  set nmales count turtles with [sex = "male"]
  set nfem count turtles with [sex = "female"]
  set pcsingle count turtles with [status = "single"]
  set pcsingle (pcsingle / pop) * 100
  set pccohab count turtles with [status = "cohabiting"]
  set pccohab (pccohab / pop) * 100
  set pcmarried count turtles with [status = "married"]
  set pcmarried (pcmarried / pop) * 100
  set pcseparated count turtles with [status = "separated"]
  set pcseparated (pcseparated / pop) * 100
  set pcdivorced count turtles with [status = "divorced"]
  set pcdivorced (pcdivorced / pop) * 100  
  set pcwidowed count turtles with [status = "widowed"]
  set pcwidowed (pcwidowed / pop) * 100
  show "births per 100,000"
  show precision ((births / startpopulation) * 100000) 0  
  show "deaths per 100,000"
  show precision ((deaths / startpopulation) * 100000) 0
  show " "  
end

to outputexpenditures                                  ; set up expenditures ready for plotting
  set houses count patches with [count turtles-here > 0]
  set totexp sum [totalexpenditure] of patches with [occupied = 1]

  set totseconddwelling sum [seconddwelling] of patches with [occupied = 1]
  set totincome sum [incanon] of patches with [occupied = 1]
  set totoldhhincome sum [oldhhincome] of patches with [occupied = 1]
  set toteffectiveincome sum [effectiveincome] of patches with [occupied = 1]
  
  set totfood sum [food] of patches with [occupied = 1]
  set totalcohol sum [alcohol] of patches with [occupied = 1]    
  set totclothing sum [clothing] of patches with [occupied = 1]  
  set tothousing sum [housing] of patches with [occupied = 1]
  set totfurniture sum [furniture] of patches with [occupied = 1]
  set tothealth sum [health] of patches with [occupied = 1]
  set tottransport sum [transport] of patches with [occupied = 1]
  set totcommunication sum [communication] of patches with [occupied = 1]
  set totrecreation sum [recreation] of patches with [occupied = 1]  
  set toteduc sum [educ] of patches with [occupied = 1]  
  set tothotels sum [hotels] of patches with [occupied = 1]  
  set totmisc sum [misc] of patches with [occupied = 1]  
  set tototherexp sum [otherexp] of patches with [occupied = 1]  
  
  if years = 0 [
    set totexp0 totexp
    set food0 totfood
    set alcohol0 totalcohol
    set clothing0 totclothing
    set housing0 tothousing
    set furniture0 totfurniture
    set health0 tothealth
    set transport0 tottransport
    set communication0 totcommunication
    set recreation0 totrecreation
    set educ0 toteduc
    set hotels0 tothotels
    set misc0 totmisc
  ]

  set totinternet sum [internet] of patches with [occupied = 1]
  set totseconddwelling sum [seconddwelling] of patches with [occupied = 1]
  set totsaved sum [saved] of patches with [occupied = 1]
  set tottelecom sum [telecom] of patches with [occupied = 1]
  set totnontelecom sum [nontelecom] of patches with [occupied = 1]
  
  set meanexp (totexp / houses)
  set meaninternet (totinternet / houses)
  set meanfood (totfood / houses)
  set meanalcohol (totalcohol / houses)
  set meanclothing (totclothing / houses)  
  set meanhousing (tothousing / houses)
  set meanfurniture (totfurniture / houses)
  set meanhealth (tothealth / houses)
  set meantransport (tottransport / houses)
  set meancommunication (totcommunication / houses)
  set meanrecreation (totcommunication / houses)
  set meaneduc (toteduc / houses)
  set meanhotels (tothotels / houses)
  set meanmisc (totmisc / houses)
  set meanotherexp (tototherexp / houses)
  set meanseconddwelling (totseconddwelling / houses)
  set meansaved (totsaved / houses)
  set meantelecom (tottelecom / houses)
  set meannontelecom (totnontelecom / houses)
  
  set pcexpcommunication (totcommunication / totexp) * 100
  set pcexpseconddwelling (totseconddwelling / totexp) * 100
  set pcexpclothing (totclothing / totexp) * 100
  set pcexpinternet (totinternet / totexp) * 100
  set pcexpsaved (totsaved / totexp) * 100
  set pcexptelecom (tottelecom / totexp) * 100
  set pcexpnontelecom (totnontelecom / totexp) * 100
  
  set pcincfood (totfood / totincome) * 100
  set pcincalcohol (totalcohol / totincome) * 100
  set pcincclothing (totclothing / totincome) * 100
  set pcinchousing (tothousing / totincome) * 100
  set pcincfurniture (totfurniture / totincome) * 100
  set pcinchealth (tothealth / totincome) * 100
  set pcinctransport (tottransport / totincome) * 100
  set pcinccommunication (totcommunication / totincome) * 100
  set pcincrecreation (totrecreation / totincome) * 100
  set pcinceduc (toteduc / totincome) * 100
  set pcinchotels (tothotels / totincome) * 100
  set pcincmisc (totmisc / totincome) * 100
  set pcincotherexp (tototherexp / totincome) * 100
  
  set pcinccommunication (totcommunication / totincome) * 100
  set pcincseconddwelling (totseconddwelling / totincome) * 100
  set pcincclothing (totclothing / totincome) * 100
  set pcincinternet (totinternet / totincome) * 100
  set pcincsaved (totsaved / totincome) * 100
  set pcinctelecom (tottelecom / totincome) * 100
  set pcincnontelecom (totnontelecom / totincome) * 100
  
  set low count patches with [occupied = 1 and incanon > 0 and incanon < 300]
  set medium count patches with [occupied = 1 and incanon >= 300 and incanon < 800]
  set high count patches with [occupied = 1 and incanon >= 800]
  set othergroup count patches with [occupied = 1 and currenttype = 6]

  set pclow ((count patches with [occupied = 1 and incanon > 0 and incanon < 300]) / houses) * 100
  set pcmedium ((count patches with [occupied = 1 and incanon >= 300 and incanon < 800]) / houses) * 100
  set pchigh ((count patches with [occupied = 1 and incanon >= 800]) / houses) * 100
   
  write low write medium write high

  set flow sum[seconddwelling] of patches with [occupied = 1 and currenttype >= 10 and currenttype <= 15] ; average second dwelling spend for each income group
  if low > 0 [set mflow (flow / low)]
  set fmed sum[seconddwelling] of patches with [occupied = 1 and currenttype >= 20 and currenttype <= 25]
  if medium > 0 [set mfmed (fmed / medium)]
  set fhigh sum[seconddwelling] of patches with [occupied = 1 and currenttype >= 30 and currenttype <= 35]
  if high > 0 [set mfhigh (fhigh / high)]
  set fother sum[seconddwelling] of patches with [occupied = 1 and currenttype = 6]

  write mflow write mfmed write mfhigh write mfother

  set type1pc ((count patches with [occupied = 1 and currenttype = 1]) / houses) * 100
  set type2pc ((count patches with [occupied = 1 and currenttype = 2]) / houses) * 100
  set type3pc ((count patches with [occupied = 1 and currenttype = 3]) / houses) * 100 
  set type4pc ((count patches with [occupied = 1 and currenttype = 4]) / houses) * 100
  set type5pc ((count patches with [occupied = 1 and currenttype = 5]) / houses) * 100 
  set type6pc ((count patches with [occupied = 1 and currenttype = 6]) / houses) * 100
end

to write_file
  let out_pcase 0
  let out_housesize 0
  let out_gender 0
  let out_age 0
  let out_composition "other"
  let out_currenttype 0
  let out_children 0
  let out_0-4 0
  let out_5-17 0
  let out_18-44 0
  let out_45-64 0
  let out_65+ 0
  let out_class "Other"
  
  if years = 0 [file-open "output2006.txt"]
  if years = 5 [file-open "output2011.txt"]
  if years = 10 [file-open "output2016.txt"]
  if years = 15 [file-open "output2021.txt"]
  if years = 20 [file-open "output2026.txt"]
  if years = 25 [file-open "output2031.txt"]  
  if years = 30 [file-open "output2036.txt"]
  
  file-write "Household ID"
  file-write "Original ID"
  file-write "No. Persons"
  file-write "Gender"
  file-write "Age of Oldest Occupant"
  file-write "composition"
  file-write "Type of Household"
  file-write "Children"
  file-write "0-4."
  file-write "5-17."
  file-write "18-44."
  file-write "45-64."
  file-write "65+ "
  file-write "Class"
    
  file-write "incanon"
  file-write "food"
  file-write "alcohol"
  file-write "clothing"
  file-write "housing"
  file-write "furniture"
  file-write "health"
  file-write "transport"
  file-write "communication"
  file-write "recreation"
  file-write "education"
  file-write "hotels"
  file-write "miscellaneous"
  file-write "other"
  file-print " "      
  
  ask patches with [occupied = 1] [
    set out_pcase 0
    set out_housesize 0
    set out_gender 0
    set out_age 0
    set out_composition "other"
    set out_currenttype currenttype
    set out_children 0
    set out_0-4 0
    set out_5-17 0
    set out_18-44 0
    set out_45-64 0
    set out_65+ 0    
    set out_class "Inactive"
    
    set out_pcase pcase
    set out_housesize count turtles-here
    set out_gender [sex] of one-of turtles-here with [age = max [age] of turtles-here]
    set out_age max [age] of turtles-here
    if count turtles-here = 1 [set out_composition "single person"]
    if count turtles-here = 2 and
      ([status] of one-of turtles-here with [age = max [age] of turtles-here] = "married" or
       [status] of one-of turtles-here with [age = max [age] of turtles-here] = "cohabiting")
        [set out_composition "couple"]
    if count turtles-here with [age >= 16] = 1 and
      count turtles-here with [age < 16] >= 1
      [set out_composition "single parent"]
    set out_children count turtles-here with [age <= 18]
    set out_0-4 count turtles-here with [age >= 0 and age <= 4]
    set out_5-17 count turtles-here with [age >= 5 and age <= 17]
    set out_18-44 count turtles-here with [age >= 18 and age <= 44]
    set out_45-64 count turtles-here with [age >= 45 and age <= 64]
    set out_65+ count turtles-here with [age >= 65]
    set out_class class
    
    file-write out_pcase
    file-write originalID
    file-write out_housesize
    file-write out_gender
    file-write out_age
    file-write out_composition
    file-write out_currenttype
    file-write out_children
    file-write out_0-4
    file-write out_5-17
    file-write out_18-44
    file-write out_45-64
    file-write out_65+
    file-write out_class
    
    file-write precision incanon 2
    file-write precision food 2
    file-write precision alcohol 2
    file-write precision clothing 2
    file-write precision housing 2
    file-write precision furniture 2
    file-write precision health 2
    file-write precision transport 2
    file-write precision communication 2
    file-write precision recreation 2
    file-write precision educ 2
    file-write precision hotels 2
    file-write precision misc 2
    file-write precision otherexp 2  
    file-print " "
  ]
  file-close
end

to followparent
  let tempid 0
  let r 0.0

  ask turtles with [age <= 21 and status != "married" and status != "cohabiting" and student = 0 and parentid > 0] [
    set tempid parentid
    if any? turtles with [who = tempid] [move-to turtle parentid]
  ]
  ask turtles with [age < 16 and count turtles-here = 1] [move-to one-of patches with [currenttype = 4]] 
end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; look up tables
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to setlimitsf
; age differences of new partnerships
; lower is the youngest person they will partner, upper is the oldest
  let r 0.0
  set r random-float 1
  if r >= 0 and r < 0.11 [set lower 10 set upper 15]
  if r >= 0.11 and r < 0.31 [set lower 5 set upper 9]
  if r >= 0.31 and r < 0.46 [set lower 3 set upper 4]
  if r >= 0.46 and r < 0.65 [set lower 1 set upper 2]
  if r >= 0.65 and r < 0.74 [set lower 0 set upper 0]
  if r >= 0.74 and r < 0.85 [set upper -1 set lower -2]
  if r >= 0.85 and r < 0.91 [set upper -3 set lower -4]
  if r >= 0.91 and r <= 1 [set upper -5 set lower -10]
end

to setlimitsm
  let r 0.0
  set r random-float 1
  if r >= 0 and r < 0.11 [set lower -15 set upper -10]
  if r >= 0.11 and r < 0.31 [set lower -9 set upper -5]
  if r >= 0.31 and r < 0.46 [set lower -4 set upper -3]
  if r >= 0.46 and r < 0.65 [set lower -2 set upper -1]
  if r >= 0.65 and r < 0.74 [set lower 0 set upper 0]
  if r >= 0.74 and r < 0.85 [set lower 1 set upper 2]
  if r >= 0.85 and r < 0.91 [set lower 3 set upper 4]
  if r >= 0.91 and r <= 1 [set lower 5 set upper 10]
end

to setagebands
  set under20 0 set twenties 0 set thirties 0
  set forties 0 set fifties 0 set sixties  0
        
  if age < 20 [set under20 1]
  if age >= 20 and age < 30 [set twenties 1]
  if age >= 30 and age < 40 [set thirties 1]
  if age >= 40 and age < 50 [set forties 1]
  if age >= 50 and age < 60 [set fifties 1]
  if age >= 60 [set sixties 1]
end

to set_household_age_bands                                    ; set household age from oldest occupant
  set houseageband 0
  if max [age] of turtles-here > 0 and max [age] of turtles-here <= 29 [set houseageband 1]
  if max [age] of turtles-here >= 30 and max [age] of turtles-here <= 39 [set houseageband 2]
  if max [age] of turtles-here >= 40 and max [age] of turtles-here <= 49 [set houseageband 3]
  if max [age] of turtles-here >= 50 and max [age] of turtles-here <= 59 [set houseageband 4]
  if max [age] of turtles-here >= 60 and max [age] of turtles-here <= 69 [set houseageband 5]
  if max [age] of turtles-here >= 70 [set houseageband 6]
  set oldest max [age] of turtles-here             
end

to showagechanges
  print " "
  type "years "
  type years
  print "Mean Age"
  show precision meanage 1
  show current_year
  set ag0 count turtles with [age >= 0 and age <= 14]
  set ag0 (ag0 / pop) * 100
  set ag1 count turtles with [age >= 15 and age <= 29]
  set ag1 (ag1 / pop) * 100
  set ag2 count turtles with [age >= 30 and age <= 44]
  set ag2 (ag2 / pop) * 100
  set ag3 count turtles with [age >= 45 and age <= 59]
  set ag3 (ag3 / pop) * 100
  set ag4 count turtles with [age >= 60 and age <= 74]
  set ag4 (ag4 / pop) * 100
  set ag5 count turtles with [age >= 75]
  set ag5 (ag5 / pop) * 100

  show precision ag0 2
  show precision ag1 2
  show precision ag2 2
  show precision ag3 2
  show precision ag4 2
  show precision ag5 2
  show ""    
  show "Total Expenditure"
  show precision ((totexp / totexp0) * 100) 1
  show "Food"
  show precision ((totfood / food0) * 100) 1
  show "Alcohol"
  show precision ((totalcohol / alcohol0) * 100) 1  
  show "Clothing"
  show precision ((totclothing / clothing0) * 100) 1  
  show "Housing"
  show precision ((tothousing / housing0) * 100) 1
  show "Furniture"
  show precision ((totfurniture / furniture0) * 100) 1  
  show "Health"
  show precision ((tothealth / health0) * 100) 1
  Show "Transport"
  show precision ((tottransport / transport0) * 100) 1
  show "Communication"
  show precision ((totcommunication / communication0) * 100) 1
  show "Recreation"
  show precision ((totrecreation / recreation0) * 100) 1
  show "Education"
  show precision ((toteduc / educ0) * 100) 1
  show "Hotels"
  show precision ((tothotels / hotels0) * 100) 1
  show "Miscellaneous"
  show precision ((totmisc / misc0) * 100) 1

  print " "
  type "Under 30    "
  print count patches with [houseageband = 1 and occupied = 1]
  type "30-39       "
  print count patches with [houseageband = 2 and occupied = 1]
  type "40-49       "
  print count patches with [houseageband = 3 and occupied = 1]
  type "50-59       "
  print count patches with [houseageband = 4 and occupied = 1]
  type "60-69       "
  print count patches with [houseageband = 5 and occupied = 1]
  type "70 and over "    
  print count patches with [houseageband = 6 and occupied = 1]
  print " "
  print "Housing"
  print precision mean [housing] of patches with [houseageband = 1 and occupied = 1] 2
  print precision mean [housing] of patches with [houseageband = 2 and occupied = 1] 2
  print precision mean [housing] of patches with [houseageband = 3 and occupied = 1] 2
  print precision mean [housing] of patches with [houseageband = 4 and occupied = 1] 2
  print precision mean [housing] of patches with [houseageband = 5 and occupied = 1] 2
  print precision mean [housing] of patches with [houseageband = 6 and occupied = 1] 2
  print "Health"
  print precision mean [health] of patches with [houseageband = 1 and occupied = 1] 2
  print precision mean [health] of patches with [houseageband = 2 and occupied = 1] 2
  print precision mean [health] of patches with [houseageband = 3 and occupied = 1] 2
  print precision mean [health] of patches with [houseageband = 4 and occupied = 1] 2
  print precision mean [health] of patches with [houseageband = 5 and occupied = 1] 2
  print precision mean [health] of patches with [houseageband = 6 and occupied = 1] 2          
  print "Transport"
  print precision mean [transport] of patches with [houseageband = 1 and occupied = 1] 2
  print precision mean [transport] of patches with [houseageband = 2 and occupied = 1] 2
  print precision mean [transport] of patches with [houseageband = 3 and occupied = 1] 2
  print precision mean [transport] of patches with [houseageband = 4 and occupied = 1] 2
  print precision mean [transport] of patches with [houseageband = 5 and occupied = 1] 2
  print precision mean [transport] of patches with [houseageband = 6 and occupied = 1] 2
  print "Food"
  print precision mean [food] of patches with [houseageband = 1 and occupied = 1] 2
  print precision mean [food] of patches with [houseageband = 2 and occupied = 1] 2
  print precision mean [food] of patches with [houseageband = 3 and occupied = 1] 2
  print precision mean [food] of patches with [houseageband = 4 and occupied = 1] 2
  print precision mean [food] of patches with [houseageband = 5 and occupied = 1] 2
  print precision mean [food] of patches with [houseageband = 6 and occupied = 1] 2
  
  print "Income"
  print precision mean [incanon] of patches with [houseageband = 1 and occupied = 1] 2
  print precision mean [incanon] of patches with [houseageband = 2 and occupied = 1] 2
  print precision mean [incanon] of patches with [houseageband = 3 and occupied = 1] 2
  print precision mean [incanon] of patches with [houseageband = 4 and occupied = 1] 2
  print precision mean [incanon] of patches with [houseageband = 5 and occupied = 1] 2
  print precision mean [incanon] of patches with [houseageband = 6 and occupied = 1] 2
  
  ask turtles [
    set livewithparents false
    if count other turtles-here with [status = "married"] = 2 or
      count other turtles-here with [status = "cohabiting"] = 2
        [set livewithparents true]
  ]

  show "Population"
  show count turtles
  show "Number of Households"
  show count patches with [occupied = 1]
  
  show "Household Types"
  show "Type 1"
  show count patches with [currenttype = 1 and occupied = 1]
  show "Type 2"
  show count patches with [currenttype = 2 and occupied = 1]
  show "Type 3"
  show count patches with [currenttype = 3 and occupied = 1]
  show "Type 4"
  show count patches with [currenttype = 4 and occupied = 1]
  show "Type 5"
  show count patches with [currenttype = 5 and occupied = 1]
  show "Type 6"
  show count patches with [currenttype = 6 and occupied = 1]
  
  show "Household Size"
  show "One"
  show count patches with [count turtles-here = 1]
  show "Two"
  show count patches with [count turtles-here = 2]
  show "Three"
  show count patches with [count turtles-here = 3]
  show "Four"
  show count patches with [count turtles-here = 4]
  Show "Five"
  show count patches with [count turtles-here = 5]
  show "Six or more"
  show count patches with [count turtles-here >= 6]                   
end

to showtypechanges
  if any? patches with [currenttype = 2 and lasttype = 1] [
    type "1 to 2 "
    show count patches with [currenttype = 2 and lasttype = 1]
    type "2 to 1 "
    show count patches with [currenttype = 1 and lasttype = 2]      

    show "Expenditure Changes"
    type "Food  "
    set fnew fnew + sum [food] of patches with [currenttype = 2 and lasttype = 1]
    set fold fold + sum [ptempfood] of patches with [currenttype = 2 and lasttype = 1]
    if fold > 0 [print precision ((fnew - fold) / fold * 100) 2]
 
    type "Alcohol  "
    set anew anew + sum [alcohol] of patches with [currenttype = 2 and lasttype = 1]
    set aold aold + sum [ptempalcohol] of patches with [currenttype = 2 and lasttype = 1]
    if aold > 0 [print precision ((anew - aold) / aold * 100) 2]

    type "Clothing  "
    set cnew cnew + sum [clothing] of patches with [currenttype = 2 and lasttype = 1]
    set cold cold + sum [ptempclothing] of patches with [currenttype = 2 and lasttype = 1]
    if cold > 0 [print precision ((cnew - cold) / cold * 100) 2]
      
    type "Housing  "
    set hnew hnew + sum [housing] of patches with [currenttype = 2 and lasttype = 1]
    set hold hold + sum [ptemphousing] of patches with [currenttype = 2 and lasttype = 1]
    if hold > 0 [print precision ((hnew - hold) / hold * 100) 2]
      
    type "Furniture  "
    set furnew furnew + sum [furniture] of patches with [currenttype = 2 and lasttype = 1]
    set furold furold + sum [ptempfurniture] of patches with [currenttype = 2 and lasttype = 1]
    if furold > 0 [print precision ((furnew - furold) / furold * 100) 2]     
 
    type "Health  "
    set healthnew healthnew + sum [health] of patches with [currenttype = 2 and lasttype = 1]
    set healthold healthold + sum [ptemphealth] of patches with [currenttype = 2 and lasttype = 1]
    if healthold > 0 [print precision ((healthnew - healthold) / healthold * 100) 2]
      
    type "Transport  "
    set tnew tnew + sum [transport] of patches with [currenttype = 2 and lasttype = 1]
    set told told + sum [ptemptransport] of patches with [currenttype = 2 and lasttype = 1]
    if told > 0 [print precision ((tnew - told) / told * 100) 2]

    type "Communication  "
    set comnew comnew + sum [communication] of patches with [currenttype = 2 and lasttype = 1]
    set comold comold + sum [ptempcommunication] of patches with [currenttype = 2 and lasttype = 1]
    if comold > 0 [print precision ((comnew - comold) / comold * 100) 2]

    type "Recreation  "
    set rnew rnew + sum [recreation] of patches with [currenttype = 2 and lasttype = 1]
    set rold rold + sum [ptemprecreation] of patches with [currenttype = 2 and lasttype = 1]
    if rold > 0 [print precision ((rnew - rold) / rold * 100) 2]
      
    type "Education  "
    set enew enew + sum [educ] of patches with [currenttype = 2 and lasttype = 1]
    set eold eold + sum [ptempeduc] of patches with [currenttype = 2 and lasttype = 1]
    if eold > 0 [print precision ((enew - eold) / eold * 100) 2]
     
    type "Hotels  "
    set hotnew hotnew + sum [hotels] of patches with [currenttype = 2 and lasttype = 1]
    set hotold hotold + sum [ptemphotels] of patches with [currenttype = 2 and lasttype = 1]
    if hotold > 0 [print precision ((hotnew - hotold) / hotold * 100) 2]      
  ]
end


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; plotting section
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

to update-plot
  set-current-plot "Expenditures"
  set-current-plot-pen "Total Expenditure"
  plot (totexp / totexp0) * 100
  set-current-plot-pen "food"
  plot (totfood / food0) * 100
  set-current-plot-pen "alcohol"
  plot (totalcohol / alcohol0) * 100
  set-current-plot-pen "clothing"
  plot (totclothing / clothing0) * 100
  set-current-plot-pen "housing"
  plot (tothousing / housing0) * 100
  set-current-plot-pen "furniture"
  plot (totfurniture / furniture0) * 100
  set-current-plot-pen "health"
  plot (tothealth / health0) * 100
  set-current-plot-pen "transport"
  plot (tottransport / transport0) * 100
  set-current-plot-pen "communication"
  plot (totcommunication / communication0) * 100
  set-current-plot-pen "recreation"
  plot (totrecreation / recreation0) * 100
  set-current-plot-pen "educ"
  plot (toteduc / educ0) * 100
  set-current-plot-pen "hotels"
  plot (tothotels / hotels0) * 100
  set-current-plot-pen "miscellaneous"
  plot (totmisc / misc0) * 100

  set-current-plot "Share of Income"
  set-current-plot-pen "pcincfood"
  plot pcincfood
  set-current-plot-pen "pcincalcohol"
  plot pcincalcohol
  set-current-plot-pen "pcincclothing"
  plot pcincclothing  
  set-current-plot-pen "pcinchousing"
  plot pcinchousing
  set-current-plot-pen "pcincfurniture"
  plot pcincfurniture
  set-current-plot-pen "pcinchealth"
  plot pcinchealth
  set-current-plot-pen "pcinctransport"
  plot pcinctransport
  set-current-plot-pen "pcinccommunication"
  plot pcinccommunication
  set-current-plot-pen "pcincrecreation"
  plot pcincrecreation
  set-current-plot-pen "pcinceduc"
  plot pcinceduc
  set-current-plot-pen "pcinchotels"
  plot pcinchotels
  ;set-current-plot-pen "pcincmisc"
  ;plot pcincmisc
  ;set-current-plot-pen "pcincotherexp"
  ;plot pcincotherexp

  set-current-plot "population"
  plot pop
  
  set-current-plot "housesize"
  plot hsize
  
  set-current-plot "Expenditures_1"
  set-current-plot-pen "food"
  plot totfood / houses
  set-current-plot-pen "alcohol"
  plot totalcohol / houses
  set-current-plot-pen "clothing"
  plot totclothing / houses
  set-current-plot-pen "housing"
  plot tothousing / houses  
  set-current-plot-pen "furniture"
  plot totfurniture / houses  
  set-current-plot-pen "health"
  plot tothealth / houses  

  set-current-plot "Expenditures_2"
  set-current-plot-pen "transport"
  plot tottransport / houses  
  set-current-plot-pen "communication"
  plot totcommunication / houses  
  set-current-plot-pen "recreation"
  plot totrecreation / houses  
  set-current-plot-pen "educ"
  plot toteduc / houses
  set-current-plot-pen "hotels"
  plot tothotels / houses
  ;set-current-plot-pen "misc"
  ;plot totmisc / houses
  ;set-current-plot-pen "otherexp"
  ;plot tototherexp / houses  

  set-current-plot "Mean Weekly Household Income"
  plot (totincome / houses)
  
  set-current-plot "effectiveincome"
  plot (toteffectiveincome / houses) 
   
  set-current-plot "Share of Income 1"
  set-current-plot-pen "pcincfood"
  plot pcincfood
  set-current-plot-pen "pcincalcohol"
  plot pcincalcohol
  set-current-plot-pen "pcincclothing"
  plot pcincclothing  
  set-current-plot-pen "pcinchousing"
  plot pcinchousing
  set-current-plot-pen "pcincfurniture"
  plot pcincfurniture
  set-current-plot-pen "pcinchealth"
  plot pcinchealth

  set-current-plot "Share of Income 2"
  set-current-plot-pen "pcinctransport"
  plot pcinctransport
  set-current-plot-pen "pcinccommunication"
  plot pcinccommunication
  set-current-plot-pen "pcincrecreation"
  plot pcincrecreation
  set-current-plot-pen "pcinceduc"
  plot pcinceduc
  set-current-plot-pen "pcinchotels"
  plot pcinchotels
  ;set-current-plot-pen "pcincmisc"
  ;plot pcincmisc
  ;set-current-plot-pen "pcincotherexp"
  ;plot pcincotherexp
  
  set-current-plot "Population Makeup"
  set-current-plot-pen "pcsingle"
  plot pcsingle
  set-current-plot-pen "pcmarried"
  plot pcmarried
  set-current-plot-pen "pccohab"
  plot pccohab
  set-current-plot-pen "pcseparated"
  plot pcseparated
  set-current-plot-pen "pcdivorced"
  plot pcdivorced  
  set-current-plot-pen "pcwidowed"
  plot pcwidowed
  
  set-current-plot "Household Size"
  set-current-plot-pen "h1"
  plot h1
  set-current-plot-pen "h2"
  plot h2
  set-current-plot-pen "h3"
  plot h3
  set-current-plot-pen "h4"
  plot h4
  
  set-current-plot "incomeband"
  set-current-plot-pen "pclow"
  plot pclow
  set-current-plot-pen "pcmedium"
  plot pcmedium
  set-current-plot-pen "pchigh"
  plot pchigh
  
  set-current-plot "types"
  set-plot-x-range 0 9
  set-plot-y-range 0 100
  set-histogram-num-bars 8
  histogram [currenttype] of patches with [occupied = 1]
end
@#$#@#$#@
GRAPHICS-WINDOW
9
1013
1627
2652
100
100
8.0
1
10
1
1
1
0
0
0
1
-100
100
-100
100
0
0
1
ticks
30.0

BUTTON
5
68
143
118
Setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
4
122
143
168
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

PLOT
319
702
622
849
Population
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" ""

PLOT
339
858
596
993
Housesize
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" ""

INPUTBOX
5
174
84
234
Households
100
1
0
Number

INPUTBOX
89
174
152
234
stop_after
30
1
0
Number

MONITOR
6
444
56
489
NIL
years
0
1
11

PLOT
632
724
888
874
Population Makeup
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"pcmarried" 1.0 0 -16777216 true "" ""
"pcsingle" 1.0 0 -13791810 true "" ""
"pccohab" 1.0 0 -1184463 true "" ""
"pcseparated" 1.0 0 -10899396 true "" ""
"pcwidowed" 1.0 0 -7500403 true "" ""
"pcdivorced" 1.0 0 -955883 true "" ""

MONITOR
711
879
778
924
NIL
pcmarried
1
1
11

MONITOR
649
879
706
924
NIL
pcsingle
1
1
11

MONITOR
782
879
841
924
NIL
pccohab
1
1
11

MONITOR
783
935
853
980
NIL
pcseparated
1
1
11

MONITOR
714
934
778
979
NIL
pcwidowed
1
1
11

MONITOR
649
933
710
978
NIL
pcdivorced
1
1
11

PLOT
916
725
1142
875
Household Size
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"h1" 1.0 0 -16777216 true "" ""
"h2" 1.0 0 -6459832 true "" ""
"h3" 1.0 0 -2674135 true "" ""
"h4" 1.0 0 -10899396 true "" ""

MONITOR
902
879
959
924
NIL
h1
1
1
11

MONITOR
966
879
1023
924
NIL
h2
1
1
11

MONITOR
1031
879
1088
924
NIL
h3
1
1
11

MONITOR
1096
880
1153
925
NIL
h4
1
1
11

PLOT
5
539
311
689
Mean Weekly Household Income
Years
£
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"income" 1.0 1 -2674135 true "" ""

PLOT
6
699
311
849
incomeband
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"pclow" 1.0 0 -2674135 true "" ""
"pcmedium" 1.0 0 -1184463 true "" ""
"pchigh" 1.0 0 -10899396 true "" ""

PLOT
1488
251
1867
486
Share of Income 1
Years
%
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"pcincfood" 1.0 0 -10899396 true "" ""
"pcincalcohol" 1.0 0 -1184463 true "" ""
"pcincclothing" 1.0 0 -2064490 true "" ""
"pcinchousing" 1.0 0 -2674135 true "" ""
"pcincfurniture" 1.0 0 -6459832 true "" ""
"pcinchealth" 1.0 0 -13791810 true "" ""

PLOT
318
540
624
690
effectiveincome
Years
£ per week
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"effectiveincome" 1.0 1 -10899396 true "" ""

PLOT
1488
10
1867
244
Expenditures_1
Years
£ per week
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"food" 1.0 0 -10899396 true "" ""
"alcohol" 1.0 0 -1184463 true "" ""
"clothing" 1.0 0 -2064490 true "" ""
"housing" 1.0 0 -2674135 true "" ""
"furniture" 1.0 0 -6459832 true "" ""
"health" 1.0 0 -14835848 true "" ""

PLOT
1881
10
2258
243
Expenditures_2
Years
£ per week
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"transport" 1.0 0 -16777216 true "" ""
"communication" 1.0 0 -1184463 true "" ""
"recreation" 1.0 0 -13840069 true "" ""
"educ" 1.0 0 -5825686 true "" ""
"hotels" 1.0 0 -7500403 true "" ""

PLOT
1881
252
2258
485
Share of Income 2
Years
%
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"pcinctransport" 1.0 0 -16777216 true "" ""
"pcinccommunication" 1.0 0 -1184463 true "" ""
"pcincrecreation" 1.0 0 -10899396 true "" ""
"pcinceduc" 1.0 0 -5825686 true "" ""
"pcinchotels" 1.0 0 -7500403 true "" ""

SLIDER
5
368
184
401
change_in_real_income%
change_in_real_income%
-50
50
0
1
1
NIL
HORIZONTAL

PLOT
633
539
955
719
types
Type
Count
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 1 -8630108 true "" ""

PLOT
215
10
1015
523
Expenditures
Years
Normalised Mean Expenditure (£)
0.0
0.0
50.0
150.0
true
true
"" ""
PENS
"Food" 1.0 0 -10899396 true "" ""
"Alcohol" 1.0 0 -1184463 true "" ""
"Clothing" 1.0 0 -2064490 true "" ""
"Housing" 1.0 0 -955883 true "" ""
"Furniture" 1.0 0 -6459832 true "" ""
"Health" 1.0 0 -5987164 true "" ""
"Transport" 1.0 0 -16777216 true "" ""
"Communication" 1.0 0 -13840069 true "" ""
"Recreation" 1.0 0 -11221820 true "" ""
"Educ" 1.0 0 -5825686 true "" ""
"Hotels" 1.0 0 -14835848 true "" ""
"Miscellaneous" 1.0 0 -8020277 true "" ""
"Total Expenditure" 1.0 0 -6565750 true "" ""

PLOT
1031
273
1477
533
Share of Income
Years
%
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"pcincfood" 1.0 0 -10899396 true "" ""
"pcincalcohol" 1.0 0 -1184463 true "" ""
"pcincclothing" 1.0 0 -2064490 true "" ""
"pcinchousing" 1.0 0 -955883 true "" ""
"pcincfurniture" 1.0 0 -6459832 true "" ""
"pcinchealth" 1.0 0 -8630108 true "" ""
"pcinctransport" 1.0 0 -16777216 true "" ""
"pcinccommunication" 1.0 0 -13840069 true "" ""
"pcincrecreation" 1.0 0 -11221820 true "" ""
"pcinceduc" 1.0 0 -5825686 true "" ""
"pcinchotels" 1.0 0 -14835848 true "" ""

SWITCH
5
280
141
313
Apply_weights
Apply_weights
0
1
-1000

TEXTBOX
12
10
162
60
Expenditure Model
20
103.0
1

MONITOR
61
445
173
490
Mean Population Age
meanage
2
1
11

SWITCH
5
240
154
273
Demographics
Demographics
0
1
-1000

SWITCH
7
321
125
354
Alignment
Alignment
0
1
-1000

SLIDER
1055
10
1236
43
Propensity_to_Marry
Propensity_to_Marry
0.1
5
1
0.01
1
NIL
HORIZONTAL

SLIDER
1055
48
1237
81
Propensity_to_Divorce
Propensity_to_Divorce
0.1
5
1
0.01
1
NIL
HORIZONTAL

SLIDER
1055
96
1239
129
Propensity_to_Cohabit
Propensity_to_Cohabit
0.1
5
1
0.01
1
NIL
HORIZONTAL

SLIDER
1055
134
1240
167
Propensity_to_Split
Propensity_to_Split
0.1
5
1
0.01
1
NIL
HORIZONTAL

SLIDER
1054
180
1241
213
Birth_Rate
Birth_Rate
0.1
5
1.1451870000000002
0.01
1
NIL
HORIZONTAL

SLIDER
1055
222
1242
255
Mortality_Rate
Mortality_Rate
0.1
5
1.3992499999999999
0.01
1
NIL
HORIZONTAL

@#$#@#$#@
## WHAT IS IT?

A program to model the effect of natural demographic change on UK spending patterns.

It is the program that generated the results for the paper: How the Ageing Population Contributes to UK Economic Activity: a microsimulation analysis. 

## HOW IT WORKS

There are two stages to the implementation. First, demographic processes are   
modelled to advance the population over time. Second, the demand expected from  
the new population is estimated.

In the demographic section, for each year and for each individual, modules are run in the following order -

mortality  
fertility  
education  
leaving home  
marriage dissolution  
cohabitation dissolution  
cohabitation formation  
marriage  
age  
return home after dissolution  
return home  
children follow parents

in more detail

Loading data

The household file is read first. This sets up patches ready to be occuppied by the agents. Next the agent file is read. Each agent moves to the house indicated by the casenumber.

Children are assigned to a parent they will be dependent upon in the event of the couple separating. In 9 out of 10 cases this is the female to reflect approximately what occurs in practice. In the birth module, all offspring depend on their mother. This could be corrected by running findparents every year but is not done because the model is insensitive to this parameter and to minimise execution time.


Mortality

Test whether the agent dies before the end of the year
	for males aged 40 and younger the probability of 
	not surviving p = 0.000736
	for males over 40 p = 0.00003 e^0.0954 age

	for females 40 and younger p = 0.000411
	for females over 40 p = 0.00001 e^0.1017 age

	source: ons life tables
		under 40s is an average
		over 40s fitted with an exponential function

	  
Birth

agents must be aged from 15 to 60  
probability of a birth in any year is calculated using three logistic equations  
derived from a pooled sample from the BHPS. Pairs of years from waves J 		to O are combined.  
Separate logistic equations are obtained. One for married women, one 			for cohabitors and one for singles and others. They are all based on 			age, number of children and age of the youngest child.  
Probabilities of twins or triplets are modelled using data from SAGE  
Technical Note no. 4.  
When a birth is to an individual not married or cohabiting and living with another, they move to a new location with a nominal 0.5 probability. This is meant to reflect the formation of households with a single parent. The model seems insensitive to the precise value of this parameter.


Education

participation in full time education is assumed up to age 16. After that,   
individuals leave education with a probability as given in SAGE technical note 4.  
At age 22, if the agent is still in education they are assumed to be qualified.  
There is no participation in education after age 22.


Leaving home

Individuals who are not living alone, are aged 18 and over, are single and have no dependents move to an unoccupied patch with a probability of 0.1. Over 25s and students have higher rates.


Marriage dissolution

Separete logistic models for males and females determine which marriages end in the current year. The model that operates for the current individual is alternately male  
of female dominated with a probability of 0.5. This effectively halves the probability of dissolution for that individual. The risk of their partner desolving the relationship restores the full probability. If an agent is selected for separation, their status is set to separated, and a newlyseparated flag is set. It will be reset  
at the start of the next years cycle. It is to prevent newly separated individuals from  
re-marrying in the current year. Next their partner is set to separated. With a probability of 0.9, the male moves to a vacant patch.


Cohabitation dissolution

The same process operated except with different probabilities.

Cohabitation formation

Separate probabilities are calculated for males and females with age and current status taken into account. In the female model, birth in the current years fertility module  
is also allowed for. If selected, the first step is to check whether there is anyone   
of appropriate age available in the population. If not the process is aborted and a warning message appears in the output window. If there is one, the turtles status is set to cohabiting and it moves to a vacant patch. Next a search is made for a partner with an age difference with a probability derived from SAGE documentation. If there is one, its status is set to cohabiting and it moves to the patch of the current turtle. If not, a wider age range is considered which has been checked previously.


Marriage formation

Couples who are already cohabiting are considered for marriage provided the cohabitation did not start in the current year. This is determined by the newcohabitation flag. If selected, the resident couple set their status to married. They do not move house.

Individuals living separately are considered for marriage in a way similar to the cohabitation module.


Age is incremented by 1 year ready for the next cycle


Returning home after separation

Individuals whose cohabitation or marriage desolved in the current year return to their parents or original home if they are aged under 30 and have no dependents. These are nominal values thought reasonable and then set to ensure the resulting household composition is what was indicated in the bhps. More investigation could be carried out but the overall model is relatively insensitive to the particular values used.


Returning home generally

With a probability of 0.01, individuals aged under 30 who are not married or cohabiting and living alone or with one other return to their original address. In many cases, they will already be at this address. This is meant to reflect the movement of younger individuals sharing accommodation for example. It makes little difference to the overall model.


Locating children

Offspring record the who number of one of their parents designated as dependent upon. For siblings this is the same. At the end of the year, all offspring check the location of this parent and move to their current location.


Expenditure Module

After the dempgraphic phase, expenditures are allocated by copying from a household of similar compositgion where the oldest person is one year older than in the current household. The constraining variables of 'household size' and 'household type' are also included as matching criteria.

This mechanism also allows the model to implicitly take account of the effect of changing
incomes as people age. As expenditure patterns are copied from older households, the
budget set is drawn from a population that has the income distribution of the older
group. This means that as the proportion of pensioners in the population increases, the
expenditure patterns are more frequently selected from a household in which the
oldest person was a pensioner in the base data set.

In addition to this intrinsic variation in incomes, it is also possible to impose a change in household incomes using the slider.


## HOW TO USE IT

First set how many households to model up to about 10,000. A few hundred might be a good starting value because the more there are the longer it takes to run. If the number entered is larger than the number of cases in the EFS, the whole EFS is processed. This can take several hours even on a fats computer. Then load in the data by clicking on the setup button then run the model by clicking go.


## THINGS TO NOTICE

As time progresses, the change in expenditure for a range of goods is shown on the main output graph. The population and mean household size are shown in graphs  
as well as expenditure data. Results are also output to file.


## THINGS TO TRY

Change parameters using the siders to see what effect it has on the model.


## CREDITS AND REFERENCES

Developed by Tony Lawson as part of a PhD project at the University of Essex  
to develop a microsimulation of household demand. Sponsored by the ESRC and BT.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
